<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$codigo_artigo = $_POST['codigo_artigo'];
$nome_artigo = $_POST['nome_artigo'];
// $categoria_artigo = $_POST['categoria_artigo'];
$categoria_artigo = 0;
$tipo_artigo = $_POST['tipo_artigo'];
$stock_artigo = $_POST['stock_artigo'];
$unidade_artigo = $_POST['unidade_artigo'];
$precoPVP_artigo = $_POST['precoPVP_artigo'];
$imposto_artigo = $_POST['imposto_artigo'];
$imposto_fornecedor_artigo = $_POST['imposto_fornecedor_artigo'];
$preco_artigo = $_POST['preco_artigo'];
$codigobarras_artigo = $_POST['codigobarras_artigo'];
$numeroserie_artigo = $_POST['numeroserie_artigo'];
$retencao_valor_artigo = $_POST['retencao_valor_artigo'];
$retencao_percenteagem_artigo = $_POST['retencao_percenteagem_artigo'];
$plano_artigo = $_POST['plano_artigo'];
$plano_2_artigo = $_POST['plano_2_artigo'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $codigo_artigo == '' || $nome_artigo == '' || $tipo_artigo == '' || $unidade_artigo == '' || $precoPVP_artigo == '' || $imposto_artigo == '' || $imposto_fornecedor_artigo == '' || $plano_artigo == '' || $plano_2_artigo == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
if($retencao_valor_artigo > $precoPVP_artigo){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}

//RECALCULATE THE PRICE -------------------------------------------------
$query = "SELECT Valor FROM faturacao_impostos WHERE ID_Imposto=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $imposto_artigo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($taxaImposto);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//calculo da taxa
$taxa = ($taxaImposto * 0.01) + 1;

//confirmação dos preços
// $precoPVP_artigo_tmp = ( $preco_artigo * $taxa );
// $precoPVP_artigo_tmp = round($precoPVP_artigo_tmp,2);

//validação
// $precoPVP_artigo = floatval($precoPVP_artigo);    
// $precoPVP_artigo_tmp = floatval($precoPVP_artigo_tmp);

// if(bccomp($precoPVP_artigo, $precoPVP_artigo_tmp, 2) != 0){
// 	$preco_artigo = ( $precoPVP_artigo / $taxa );
// 	$preco_artigo = round($preco_artigo,4);
// }

//Para estar sempre correcto utilizando o PVP
// $preco_artigo = ( $precoPVP_artigo / $taxa );
// $preco_artigo = round($preco_artigo,4);

//Para estar sempre correcto utilizando o Unitário
$precoPVP_artigo = ( $preco_artigo * $taxa );
$precoPVP_artigo = round($precoPVP_artigo,4);
//-----------------------------------------------------------------------

//VERIFICAR SE CODIGO EXISTE --------------------------------------------
$query = "SELECT COUNT(*) FROM faturacao_artigos WHERE Codigo=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("s", $codigo_artigo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($counterCodigo);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($counterCodigo > 0){
	$response["errors"] = true;
	$response["codigo"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS005";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//VERIFICAR SE CODIGO BARRAS EXISTE -------------------------------------
if($codigobarras_artigo != ''){
	$query = "SELECT COUNT(*) FROM faturacao_artigos WHERE CodigoBarras=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $codigobarras_artigo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($counterCodigoBarras);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($counterCodigoBarras > 0){
		$response["errors"] = true;
		$response["codigobarras"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS008";
		die(json_encode($response));
	}
}
//-----------------------------------------------------------------------

//INSERT DB -------------------------------------------------------------
$query = "INSERT INTO faturacao_artigos(Nome, Codigo, Tipo, CodigoBarras, SerialNumber,ID_Categoria, ID_Unidade, Preco, ID_Imposto, PrecoPVP, RetencaoValor, RetencaoPercentagem, Stock, PlanoContas, ID_Imposto_Fornecedor, PlanoContasCompras) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssddsdsssssss", $nome_artigo, $codigo_artigo, $tipo_artigo, $codigobarras_artigo, $numeroserie_artigo, $categoria_artigo, $unidade_artigo, $preco_artigo, $imposto_artigo, $precoPVP_artigo, $retencao_valor_artigo, $retencao_percenteagem_artigo, $stock_artigo, $plano_artigo, $imposto_fornecedor_artigo, $plano_2_artigo );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS009";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS010";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//VERIFICAR SE IMPOSTO JÁ BLOQUEADO -------------------------------------
$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $imposto_artigo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($impostoUsed);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS012";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($impostoUsed < 1){
	//INSERT DB ---------------------------------------------------------
	$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $imposto_artigo );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS013";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS014";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-------------------------------------------------------------------
}

//IMPOSTO DO FORNECEDOR
$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $imposto_fornecedor_artigo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($impostoUsed2);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS012";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($impostoUsed2 < 1){
	//INSERT DB ---------------------------------------------------------
	$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $imposto_fornecedor_artigo );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS013";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS014";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-------------------------------------------------------------------
}
//-----------------------------------------------------------------------

//GET NEXT CODIGO ARTIGO ----------------------------------------------------
$query = "SELECT ID_Artigo FROM faturacao_artigos WHERE Codigo = ?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//result
	$stmt -> bind_param("s", $codigo_artigo);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS015";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($idArtigo);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS016";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//log sistema - processo
$descricao_log ="Création du produit (Modal) (code: ".$codigo_artigo.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response['idArtigo'] = $idArtigo;
$response['impostoID'] = $imposto_artigo;
$response['planoCode'] = $plano_artigo;
$response['planoComprasCode'] = $plano_2_artigo;
$response['motivoID'] = 0;
$response['NextID'] = $codigo_artigo+1;
die(json_encode($response));
?>