<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(398,542,16,1273,123);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDocument = $_POST['idDocument'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idDocument == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//CHECK PAYMENT ---------------------------------------------------------
$query = "SELECT ID_Compra, Data, TotalPago, Observacoes FROM faturacao_compras_pagamentos WHERE ID_Liquidacao=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("s", $idDocument);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $idCompra, $DataPagamento, $TotalPagoPagamento, $ObservacoesPagamento );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($DataPagamento) && $DataPagamento != '' ? $DataPagamento : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET DATA ACHAT --------------------------------------------------------
$query = "SELECT Numero, Estado, TotalCreditado, TotalLiquidado FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("s", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003A";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $NumeroCompra, $EstadoCompra, $TotalCreditadoCompra, $TotalLiquidadoCompra );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003B";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//DELETE DB ------------------------------------------------------------
$query = "DELETE FROM faturacao_compras_pagamentos WHERE ID_Liquidacao=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idDocument );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//UPDATE ACHAT ------------------------------------------------------------
$newTotalLiquidado = $TotalLiquidadoCompra - $TotalPagoPagamento;
if($newTotalLiquidado < 0 ) $newTotalLiquidado = 0;
if($newTotalLiquidado < $TotalCreditadoCompra ) $newTotalLiquidado = $TotalCreditadoCompra;

$query = "UPDATE faturacao_compras SET TotalLiquidado = ?, Estado = 'Aberto' WHERE ID_Compra=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sd", $newTotalLiquidado, $idCompra );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//process movements
$descricaoPagamento = $data[398]['trad']." ".$DataPagamento." - ".$ObservacoesPagamento;
anulacaoMovimentosAnteriores($sqli_connection, $idCompra, $DataPagamento, $descricaoPagamento, $TotalPagoPagamento, 0, 0, $data);
//----------------------------------------------------------------------

//log sistema - processo
$descricao_log = $data[542]['trad']." (".$data[16]['trad'].": ".$NumeroCompra." | ".$data[1273]['trad'].": ".$DataPagamento." ".$ObservacoesPagamento.")";
insert_log(0,"Apagar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));


// ==================================
// Anulação de movimentos anteriores
// ==================================
function anulacaoMovimentosAnteriores($sqli_connection, $idCompra, $dataNew, $descricaoPagamento, $valorPagamento, $valorTVA, $valorUnit, $data){
	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
			(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Codigo, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Fornecedor,
			GrossTotal,	NetTotal, TaxPayable
			FROM faturacao_compras WHERE ID_Compra=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCompra);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP, $totalUnit, $totalTVA );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = $data[542]['trad'].' ('.$data[16]['trad'].') - '.$numeroDoc.' - '.$numFornecedor.' - '.$nomeFornecedor.' - '.$descricaoPagamento;

	//calculate values
	// $totalPVP = $totalPVP - $totalPVP_NC;
	// $totalUnit = $totalUnit - $totalUnit_NC;
	// $totalTVA = $totalTVA - $totalTVA_NC;
	
	$totalPVP = $valorPagamento;
	$totalUnit = $valorTVA;
	$totalTVA = $valorUnit;

	/*if($planoFornecedor > 0){
		$tipoMovimento = 'D';
		// insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
		insertMovimentoContabilistico($planoFornecedor, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}*/

	//PROCESS MOVEMENT FOR DOCUMENT
	if($planoBanco > 0){
		$query = "SELECT 
				(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_compras.ID_Banco) AS Banco
			FROM faturacao_compras WHERE ID_Compra=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idCompra);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "HELP003";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($nomeBanco);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP004";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//MOVEMENT
		$textoBanco = $texto.' - '.$data[123]['trad'].': '.$nomeBanco;
		// $tipoMovimentoBanco = 'C';
		// insertMovimentoContabilistico($planoBanco, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
		$tipoMovimentoBanco = 'C';
		insertMovimentoContabilisticoManual($planoBanco, $planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimentoBanco, $dataNew, 'A');
	} else {
		$tipoMovimentoBanco = 'C';
		insertMovimentoContabilisticoManual('', $planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimentoBanco, $dataNew, 'A');
	}

	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
}
?>