<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(16,1208,77,1599);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idCompra = $_POST['idCompra'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idCompra == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Data, Validade, TotaRetencao, Numero FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $data, $validade, $retencaoTotal, $numeroCompra);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado != 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "usado";
	$response["line"] = "FATS003";
	$response["message"] = "Compra já finalizada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($data) && $data != '' ? $data : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
$dataNew = $data;
$validadeNew = $validade;
$dataAtualizacao = date("d/m/Y H:i:s");

$systemEntryDateUpdate = date("Y-m-d H:i:s");
$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
// $retencaoCalc = round($retencaoTotal,2);
$retencaoCalc = $retencaoTotal;
// $totalLiquidado = $retencaoCalc;

// DEFINE NEW NUMBER
$query = "UPDATE faturacao_compras SET Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, SystemEntryDate=?, Estado='Aberto' WHERE ID_Compra = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssdssd", $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $systemEntryDateUpdate, $idCompra);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA025";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//UPDATE STOCKS
$stockUpdateResult = increaseArticlesStock($idCompra, 'faturacao_compras', 'ID_Compra');
if($stockUpdateResult != true){
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA027";
	$response["message"] = 'Falha ao atualizar stocks.';
	die(json_encode($response));
}

//------------------------------------------------------------------------
//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
//------------------------------------------------------------------------
$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
			(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Codigo, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Fornecedor,
			GrossTotal, NetTotal, TaxPayable
		FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP, $totalUnit, $totalTVA );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA029";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//PROCESS MOVEMENT FOR DOCUMENT
$texto = $data2[16]['trad'].' ('.$data2[1208]['trad'].') - '.$numeroDoc.' - '.$numFornecedor.' - '.$nomeFornecedor;
/*if($planoFornecedor > 0){
	$tipoMovimento = 'C';
	// insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
	insertMovimentoContabilisticoManual($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento, $dataNew, 'A');
}*/

//LINES -- ARTICLES
$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA), ID_Imposto FROM faturacao_compras_linhas WHERE ID_Compra=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoArtigo, $codigoArtigo, $totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo, $id_imposto_artigo );
	while ($stmt -> fetch()) {
		//PROCESS MOVEMENT ARTICLE
		if($planoArtigo > 0){
			$textoArtigo = $texto.' - '.$data2[77]['trad'].' - '.$codigoArtigo;
			$tipoMovimentoArtigo = 'D';
			$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo, 'totalUnit'=>$totalUnit_Artigo, 'totalTVA'=>$totalTVA_Artigo, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if(isset($dataArtigos)){
	foreach ($dataArtigos as $line) {
			$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
			if($Edited_TotalPVP > 0){
				// insertMovimentoContabilistico($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo']);
				// insertMovimentoContabilisticoManual($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo'], $dataNew, 'A');
				insertMovimentoContabilisticoManual($line['plano'], $planoFornecedor, $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $dataNew, 'A', $line['id_imposto_artigo'], 0);
			}
	}
}

//LINES -- TVA
$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_linhas.ID_Imposto) AS Imposto, 
			TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA), ID_Imposto 
		FROM faturacao_compras_linhas WHERE ID_Compra=? GROUP BY ID_Imposto";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $id_imposto_TVA );
	while ($stmt -> fetch()) {
		//PROCESS MOVEMENT ARTICLE
		if($planoTVA > 0){
			$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;
			$textoTVA = $texto.' - '.$data2[1599]['trad'].' - '.$nomeTVA.': '.$percentagemTVA.'%';
			$tipoMovimentoTVA = 'D';
			$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA, 'totalUnit'=>$totalUnit_TVA, 'totalTVA'=>$totalTVA_TVA, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if(isset($dataTVA)){
	foreach ($dataTVA as $line) {
		// insertMovimentoContabilistico($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo']);
		// insertMovimentoContabilisticoManual($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo'], $dataNew, 'A');
		insertMovimentoContabilisticoManual($line['plano'], $planoFornecedor, $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $dataNew, 'A', $line['id_imposto_TVA'], 1);
	}
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Finalisation de l'achat (numéro: ".$numeroCompra.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>