<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idMovimento = $_POST['idMovimento'];
$data_movimento = $_POST['data_movimento'];
$plano_movimento = $_POST['plano_movimento'];
$plano_movimento_2 = $_POST['plano_movimento_2'];
$codetva_movimento = $_POST['codetva_movimento']; //CodeTVA
$includeTva = $_POST['includeTva']; //InclTVA
$valor_movimento = $_POST['valor_movimento'];
$descricao_movimento = $_POST['descricao_movimento'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idMovimento == '' || $data_movimento == '' || $plano_movimento == '' || $plano_movimento_2 == '' || $valor_movimento == '' || $descricao_movimento == ''  ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//UPDATE PARENTS ---------------------------------------------------------
$tmpDT = DateTime::createFromFormat('d/m/Y', $data_movimento);
$dataProcessed = $tmpDT->format('d/m/Y H:i:s');
$PlanoContasDebito = 0;
$PlanoContasCredito = 0;

//Process Movimentos Débito
$TotalPVP = $valor_movimento;
$PlanoContasDebito = $plano_movimento;
$PlanoContasCredito = $plano_movimento_2;

$totalIVA = 0;
$percentageTVA = 0;
$percentageTVA_tmp = 0;
if($codetva_movimento < 1 || !$codetva_movimento) {
	$codetva_movimento = 0;
}else{ 
	$totalIVA = $valor_movimento; 

	$query = "SELECT Valor FROM faturacao_impostos WHERE ID_Imposto = ? ";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codetva_movimento);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS001AAA";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($percentageTVA_tmp);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS002AAA";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	if($percentageTVA_tmp != null) $percentageTVA = $percentageTVA_tmp;
}

if($includeTva < 1 || !$includeTva) {
	$includeTva = 0;
	$totalIVA = 0; 
}

if($planoEcriture == '' || $planoUsado == true ){
	$query = "UPDATE faturacao_movimentos_contabilisticos SET Data=?, PlanoContas_Debito=?, PlanoContas_Credito=?, Descricao=?, Total_PVP=?, NaturezaMovimento='M', ID_ImpostoTVA=?, PercentageTVA=?, Total_TVA=?, IncludeTVA=? WHERE ID_Movimento=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssssssssd", 
		            $dataProcessed, 
		            $PlanoContasDebito, 
		            $PlanoContasCredito, 
		            $descricao_movimento, 
		            $TotalPVP, 
		            $codetva_movimento, 
		            $percentageTVA, 
		            $totalIVA, 
		            $includeTva, 
		            $idMovimento
		        );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001AA";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002BB";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Édition du Mouvement Comptable (".$descricao_movimento.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>