<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET SNC TABLE IN USE --------------------------------------------------
$snc_table = getSncBaseTable();

//GET POST VARS ---------------------------------------------------------
$idBanco = $_POST['idBanco'];
$descricao_banco = $_POST['descricao_banco'];
$bvr_banco = $_POST['bvr_banco'];
$compte_lapost1_banco = $_POST['compte_lapost1_banco'];
$compte_lapost2_banco = $_POST['compte_lapost2_banco'];
$debito_banco = $_POST['debito_banco'];
$credito_banco = $_POST['credito_banco'];
$flagPredefinirEdit = $_POST['flagPredefinirEdit'];
$plano_banco = $_POST['plano_banco'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idBanco == '' || $descricao_banco == '' || $bvr_banco == '' || $compte_lapost1_banco == '' || $compte_lapost2_banco == '' || $debito_banco == '' || $credito_banco == '' || $plano_banco == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//CHECK IF CAN BE UPDATED ------------------------------------------------
$query = "SELECT Usado, Nome, (SELECT Usado FROM faturacao_accounts WHERE faturacao_accounts.ID_Account=faturacao_bancos_fornecedores.ID_Account) FROM faturacao_bancos_fornecedores WHERE ID_BancoFornecedor = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idBanco);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($usado, $nomeOrigin, $usadoAccount);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add info to main array
if($usado > 0 || $usadoAccount > 0 ) {
	// $response["errors"] = true;
	// $response["type"] = "query";
	// $response["line"] = "FATS003";
	// $response["message"] = 'Conta Bloqueada';
	// die(json_encode($response));
	$descricao_banco = $nomeOrigin;
}
//------------------------------------------------------------------------

//UPDATE DB (REMOVE ALL PREDEFINIDAS) -----------------------------------
if($flagPredefinirEdit == 1){
	$query = "UPDATE faturacao_bancos_fornecedores SET Predefinido=0";

	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------

//INSERT DB --------------------------------------------------------------
$query = "UPDATE faturacao_bancos_fornecedores SET Nome=?, DebitoInicial=?, CreditoInicial=?, Predefinido=?, CodigoBVR=?, CodigoBVR_LP1=?, CodigoBVR_LP2=?, PlanoContas=? WHERE ID_BancoFornecedor=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssdssssd", $descricao_banco, $debito_banco, $credito_banco, $flagPredefinirEdit, $bvr_banco, $compte_lapost1_banco, $compte_lapost2_banco, $plano_banco, $idBanco);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Édition du banque fournisseur  (".$descricao_banco.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>