<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDados = $_POST['idConta'];

// CHECK IF CAN BE REMOVED ----------------------------------------------
$query = "SELECT Usado, ContaSistema  FROM faturacao_accounts WHERE ID_Account=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $usado, $contaSistema );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//Reject if can't be removed
if($usado > 0 || $contaSistema > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = "Conta bloqueada.";
	die(json_encode($response));
}
//CHECK IF ASSOCIATED TO CLIENTS
$query = "SELECT COUNT(*)  FROM faturacao_clientes WHERE ID_Account=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $counterClientes );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//Reject if can't be removed
if($counterClientes > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["cliente"] = true;
	$response["line"] = "FATS006";
	$response["message"] = "Conta associada a cliente(s).";
	die(json_encode($response));
}
//CHECK IF ASSOCIATED TO BANKS 
$query = "SELECT COUNT(*)  FROM faturacao_bancos WHERE ID_Account=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $counterBancos );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS008";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//Reject if can't be removed
if($counterBancos > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["banco"] = true;
	$response["line"] = "FATS009";
	$response["message"] = "Conta associada a banco(s).";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_accounts WHERE ID_Account=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idDados );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));
?>