<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/Bvr.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idAchat = $_POST['idAchat'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idAchat == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//VERIFICA SE PODE SER FINALIZADO ---------------------------------------
	$query = "SELECT Estado FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idAchat);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Estado);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($Estado != 'Rascunho') {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003A";
		$response["message"] = "Achat já processada!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//UPDATE DB -------------------------------------------------------------
	//prepare vars
	$dataAtualizacao = date("d/m/Y H:i:s");
	$utilizadorAtualizacao = $id_utilizador;
	$estadoUpdate = 'Confirmado';

	// DEFINE NEW NUMBER
	$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_contrats_achats;";
	$maxID = getMaxNumberDocument($queryStmt);
	$initNumber = 900000 + getInitNumber("NumeroInicial_CACH","faturacao_personalizar_documentos", "", 0);
	if($nextID < $initNumber && $maxID < 1){
		$query = "UPDATE faturacao_contrats_achats SET Numero = ".$initNumber.", Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Achat = ?";
	}else{
		$query = "UPDATE faturacao_contrats_achats SET Numero = (CASE WHEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_contrats_achats) AS SubNumeroMaxP) > 0 THEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_contrats_achats) AS SubNumeroMaxS) + 1 ELSE 900001 END), Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Achat = ?";
	}
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sdsd", $estadoUpdate, $utilizadorAtualizacao, $dataAtualizacao, $idAchat);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
	
	//GET NUMBER ---------------------------------------
	$query = "SELECT Numero FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idAchat);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($NumeroAchat);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($Estado != 'Rascunho') {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003A";
		$response["message"] = "Achat já processada!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}


//log sistema - processo
$descricao_log ="Finalisation du contrat de achat (id: ".$idAchat." - ".$NumeroAchat.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>