<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/Bvr.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$cliente = $_POST['cliente'];
$numero = $_POST['numero'];
$data = $_POST['data'];
$duree = $_POST['duree'];
$duree_type = $_POST['duree_type'];
$debut = $_POST['debut'];
$location = $_POST['location'];
$emolument = $_POST['emolument'];
$pagamento = $_POST['pagamento'];
$tva_exclue = $_POST['tva_exclue'];
$referencia = $_POST['referencia'];
$remarque = $_POST['remarque'];
$decompte = $_POST['decompte'];
$vendeur_1 = $_POST['vendeur_1'];
$vendeur_2 = $_POST['vendeur_2'];
$resp_client_1 = $_POST['resp_client_1'];
$resp_client_2 = $_POST['resp_client_2'];
$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];

//SYSTEM FIELDS --------------------------------------------------------
$timestamp = microtime(true);
$dataCriacao = date("d/m/Y H:i:s");
$dataAtualizacao = date("d/m/Y H:i:s");
$utilizadorCriacao = $id_utilizador;
$utilizadorAtualizacao = $id_utilizador;
$estado = 'Rascunho';
//------------------------------------------------------------------------

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $cliente == '' || $data == '' || $duree == '' || $debut == '' || $location == '' || $emolument == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

if( sizeof($linhas) < 1){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}

if($vendeur_1 == $vendeur_2){
	// $vendeur_2 = 0;
}
//------------------------------------------------------------------------

//CHECK LINES
if(!is_array($linhas) || empty($linhas)){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000x";
	$response["lines_empty"] = true;
	$response["message"] = "";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET CLIENT DATA --------------------------------------------------------
$query = "SELECT Nif, Endereco, CodigoPostal, Cidade, Regiao, Pais, Email, Codigo, Titulo, Nome, Apelido, vencimento FROM faturacao_clientes WHERE ID_Cliente = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Nif, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Email, $CodigoCliente, $Titulo, $Nome, $Apelido, $vencimento );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//process fields
if( trim($Endereco) == '' ) $Endereco = '-';
if( trim($CodigoPostal) == '' ) $CodigoPostal = '-';
if( trim($Cidade) == '' ) $Cidade = '-';
if( trim($Regiao) == '' ) $Regiao = '-';
if( trim($Pais) == '' ) $Pais = '-';

if( trim($Titulo) == '' ) $Titulo = NULL;
if( trim($Nome) == '' ) $Nome = NULL;
if( trim($Apelido) == '' ) $Apelido = NULL;
//------------------------------------------------------------------------

//INSERT NEW DOCUMENT ----------------------------------------------------

//prepare some fields
$duree_final = $duree." ".$duree_type;
if($duree == 'Indéterminée') $duree_final = $duree;
$pagamento = $vencimento;

//inserting
$query = "INSERT INTO faturacao_licences (ID_Cliente, EnderecoCliente, CodigoPostalCliente, CidadeCliente, RegiaoCliente, EmailCliente, PaisCliente, ID_Vendedor_Primeiro, ID_Vendedor_Segundo, Data, Debut, Duree, Paiment, Referencia, Remarque, Location_Mensuelle, Emolument_Admin, TVA_Exclue_Primeiro, TVA_Exclue_Segundo, Estado, DataCriacao, ID_Utilizador_Criacao, DataAtualizacao, ID_Utilizador_Atualizacao, TimeStamp_Location, ID_ResponsavelPrimeiro, ID_ResponsavelSegundo, Decompte_pages,
			TituloCliente,
			NomeCliente,
			ApelidoCliente) 
	VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param(
		"dssssssddssssssssssssdsdsddssss", 
		$cliente,
		$Endereco,
		$CodigoPostal,
		$Cidade,
		$Regiao,
		$Email,
		$Pais,
		$vendeur_1,
		$vendeur_2,
		$data,
		$debut,
		$duree_final,
		$pagamento,
		$referencia,
		$remarque,
		$location,
		$emolument,
		$tva_exclue,
		$tva_exclue,
		$estado,
		$dataCriacao,
		$utilizadorCriacao,
		$dataAtualizacao,
		$utilizadorAtualizacao,
		$timestamp,
		$resp_client_1,
		$resp_client_2,
		$decompte,
		$Titulo,
		$Nome,
		$Apelido
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA010";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA011";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET DOCUMENT ID
$query = "SELECT ID_Licence FROM faturacao_licences  WHERE TimeStamp_Location = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("s", $timestamp);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA012";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idLicence);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA013";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $idLicence < 1){
	$response["errors"] = true;
	$response["type"] = "FTGA014";
	$response["message"] = "Licence invalid";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//PROCESS LINES ----------------------------------------------------------
$numLinha = 1;
foreach ($linhas as $linha) {
	//init vars
	$ProductCode = '';
	$SerialNumber = '';
	$Quantidade = 1;

	//GET ARTICLE DATA ---------------------------------------------------
	$query = "SELECT  Codigo, SerialNumber FROM faturacao_artigos WHERE ID_Artigo = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA015";
			$response["message"] = $stmt -> error;
			deleteRecord($idLicence);
			die(json_encode($response));
		}
		$stmt -> bind_result($ProductCode, $SerialNumber);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA016";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idLicence);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------

	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_licences_linhas (ID_Licence, ID_Artigo, 
		NumeroLinha, ProductCode, ProductDescription, SerialNumber, Quantidade ) 
		VALUES (?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddsssd", $idLicence, $linha['artigo'], $numLinha, $ProductCode, $linha['descricao'], $SerialNumber, $Quantidade );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA019";
			$response["message"] = $stmt -> error;
			deleteRecord($idLicence);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idLicence);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	$numLinha++;

	//BLOCK ARTICLE ------------------------------------------------------
	$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020A";
			$response["message"] = $stmt -> error;
			deleteRecord($idLicence);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020B";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idLicence);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
}
//------------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
if( $finalizarDocumento > 0 ){
	//prepare vars
	$dataAtualizacao = date("d/m/Y H:i:s");
	$utilizadorAtualizacao = $id_utilizador;
	$estadoUpdate = 'Confirmado';

	// DEFINE NEW NUMBER
	$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_licences;";
	$maxID = getMaxNumberDocument($queryStmt);
	$initNumber = 700000 + getInitNumber("NumeroInicial_CLIC","faturacao_personalizar_documentos", "", 0);
	if($nextID < $initNumber && $maxID < 1){
		$query = "UPDATE faturacao_licences SET Numero = ".$initNumber.", Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Licence = ?";
	}else{
		$query = "UPDATE faturacao_licences SET Numero = (CASE WHEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_licences) AS SubNumeroMaxP) > 0 THEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_licences) AS SubNumeroMaxS) + 1 ELSE 700001 END), Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Licence = ?";
	}
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sdsd", $estadoUpdate, $utilizadorAtualizacao, $dataAtualizacao, $idLicence);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			deleteRecord($idLicence);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idLicence);
		die(json_encode($response));
	}

	//log sistema - processo
	$descricao_log ="Création et finalisation de contrat de licence (id: ".$idLicence.")";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);
	
	$response["licence"] = $idLicence;
}else{
	$response["licence"] = $idLicence;

	//log sistema - processo
	$descricao_log ="Création de contrat de licence (id: ".$idLicence.")";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);
}
//------------------------------------------------------------------------

//BLOCK CLIENT -----------------------------------------------------------
$query = "UPDATE faturacao_clientes SET Usado=1 WHERE ID_Cliente=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = $stmt -> error;
		deleteRecord($idLicence);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA028";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idLicence);
	die(json_encode($response));
}
//------------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_licences WHERE ID_Licence=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_licences_linhas WHERE ID_Licence=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}
?>