<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idLocation = $_POST['idDocumento'];
$data_termo = $_POST['data_termo'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idLocation == '' || $data_termo == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ANULADO ------------------------------------------
$query = "SELECT Estado FROM faturacao_locations WHERE ID_Location=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idLocation);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho' || $Estado == 'Anulado') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Location non valide!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//VERIFY DATE AND UPDATE DB ---------------------------------------------
$checkDate = DateTime::createFromFormat('d/m/Y', $data_termo);
if($checkDate){
	$dataAtualizacao = date("d/m/Y H:i:s");

	$query = "UPDATE faturacao_locations SET DataTermo = ?, 
			ID_Utilizador_Atualizacao=?, DataAtualizacao=? 
			WHERE ID_Location=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sdsd", $data_termo, $id_utilizador, $dataAtualizacao, $idLocation );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}else{
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS006";
	$response["data_invalida"] = true;
	$response["message"] = 'Date invalidé';
	die(json_encode($response));
}
//----------------------------------------------------------------------


//log sistema - processo
$descricao_log ="Résilier du contrat de location (id: ".$idLocation." | Date: ".$data_termo.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>