<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idLocation = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();
$data = "";
//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idLocation == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idLocation == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_Location,
		Numero,
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_locations.ID_Cliente) AS Cliente,
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente,
		(SELECT Nome FROM faturacao_vendedores WHERE faturacao_vendedores.ID_Vendedor = faturacao_locations.ID_Vendedor_Primeiro) AS VendedorPrimeiro,
		(SELECT Nome FROM faturacao_responsavel_contratos WHERE faturacao_responsavel_contratos.ID_RespContrato = faturacao_locations.ID_Vendedor_Segundo) AS VendedorSegundo,
		Data,
		Debut,
		Duree,
		(SELECT Vencimento FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_locations.ID_Cliente) as Vencimento,
		Referencia,
		Remarque,
		Location_Mensuelle,
		Emolument_Admin,
		TVA_Exclue_Primeiro,
		TVA_Exclue_Segundo,
		Estado,
		DataCriacao,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_locations.ID_Utilizador_Criacao) AS ID_Utilizador_Criacao,
		DataAtualizacao,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_locations.ID_Utilizador_Atualizacao) AS ID_Utilizador_Atualizacao,
		(SELECT CONCAT(Prenom,' ',Nome) FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_locations.ID_ResponsavelPrimeiro) AS ResponsavelPrimeiro,
		(SELECT CONCAT(Prenom,' ',Nome) FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_locations.ID_ResponsavelSegundo) AS ResponsavelSegundo,
		Decompte_pages,
		DataTermo,
		CONCAT(NomeCliente,' ',ApelidoCliente) AS ClienteNome,
		(SELECT Suspendu FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_locations.ID_Cliente)
		FROM faturacao_locations WHERE ID_Location=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idLocation);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Location'],
	        	$objectData['Numero'],
	        	$objectData['Cliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['VendedorPrimeiro'],
	        	$objectData['VendedorSegundo'],
	        	$objectData['Data'],
	        	$objectData['Debut'],
	        	$objectData['Duree'],
	        	$objectData['Paiment'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Location_Mensuelle'],
	        	$objectData['Emolument_Admin'],
	        	$objectData['TVA_Exclue_Primeiro'],
	        	$objectData['TVA_Exclue_Segundo'],
	        	$objectData['Estado'],
	        	$objectData['DataCriacao'],
	        	$objectData['ID_Utilizador_Criacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['ID_Utilizador_Atualizacao'],
	        	$objectData['ResponsavelPrimeiro'],
	        	$objectData['ResponsavelSegundo'],
	        	$objectData['Decompte_pages'],
	        	$objectData['DataTermo'],
	        	$objectData['ClienteNome'],
	        	$objectData['Suspendu']
			);
	$stmt -> fetch();
	$stmt -> close();

	//processar país
	$objectData['PaisFull'] = getCountryByISO2($objectData['PaisCliente']);

	//process name
	if($objectData['ClienteNome']) $objectData['Cliente'] = $objectData['ClienteNome'];

} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA FATURA ------------------------------------------
$query = "SELECT ID_Linha,
		ID_Artigo,
		NumeroLinha,
		ProductCode,
		ProductDescription,
		SerialNumber,
		Quantidade
		FROM faturacao_locations_linhas WHERE ID_Location=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idLocation);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($id_linha, $id_artigo, $num_linha, $codigo_artigo, $descricao, $serial_number, $quantidade );
	while ($stmt -> fetch()) {
		$datalin[] = array(
		        	"id_linha" => $id_linha,
		        	"id_artigo" => $id_artigo,
		        	"num_linha" => $num_linha,
		        	"codigo_artigo" => $codigo_artigo,
		        	"descricao" => nl2br($descricao),
		        	"serial_number" => $serial_number,
		        	"quantidade" => $quantidade,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $datalin;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>