<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDevis = $_POST['idDevis'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idDevis == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Exportada, TotalPagar FROM faturacao_devis WHERE ID_Devis=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDevis);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $Bloqueada, $totalPagamento);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003A";
	$response["message"] = "Devis em rascunho!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
if($Estado == 'Anulado') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003B";
	$response["message"] = "Devis já anulada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//Check if Blocked
if($Bloqueada == 1) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003C";
	$response["message"] = "Devis bloqueada!";
	$response["bloqueada"] = true;
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//UPDATE DB -------------------------------------------------------------
$dataAtualizacao = date("d/m/Y H:i:s");

$query = "UPDATE faturacao_devis SET Estado = 'Anulado', TotalLiquidado=?, TotalLiquidadoDocumento=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=? WHERE ID_Devis=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssssd", $totalPagamento, $totalPagamento, $id_utilizador, $dataAtualizacao, $idDevis );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Annulation du Devis (id: ".$idDevis.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>