<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFatura = $_POST['idDocument'];
$typeDoc = $_POST['typeDoc'];
	

//DEFINE VARS ------------------------------------------------------------
$fieldIdName = '';
$tableName = '';
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFatura == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000A";
	die(json_encode($response));
}

//MAIN DOCUMENT TABLE NAME
switch ($typeDoc) {
	case 'FA':
		$fieldIdName = 'ID_Fatura';
		$tableName = 'faturacao_faturas';
		break;
	case 'FS':
		$fieldIdName = 'ID_FaturaSimplificada';
		$tableName = 'faturacao_faturas_simplificadas';
		break;
	case 'FR':
		$fieldIdName = 'ID_FaturaRecibo';
		$tableName = 'faturacao_faturas_recibo';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS000B";
		die(json_encode($response));
		break;
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ".$fieldIdName.", 
		ID_Serie,  
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = ".$tableName.".ID_Serie) AS Serie,  
		Numero,  
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS Simbolo,
		TaxaMoeda,
		Data,
		TotalLiquidado,
		TotalPagar,
		InvoiceType,
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = ".$tableName.".ID_Cliente) AS Cliente,
		(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = ".$tableName.".ID_Cliente) AS Codigo,
		(SELECT Suspendu FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = ".$tableName.".ID_Cliente) AS Suspendu
		FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Fatura'],
	        	$objectData['ID_Serie'],
	        	$objectData['Serie'],
	        	$objectData['Numero'],
	        	$objectData['Moeda'],
	        	$objectData['ISOCode'],
	        	$objectData['Simbolo'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Data'],
	        	$objectData['TotalLiquidado'],
	        	$objectData['TotalPagar'],
	        	$objectData['InvoiceType'],
	        	$objectData['Cliente'],
	        	$objectData['Codigo'],
	        	$objectData['Suspendu']
			);
	$stmt -> fetch();
	$stmt -> close();

	$objectData['ValorPagavel'] = $objectData['TotalPagar'];
	$objectData['ValorPagavel_Estrangeiro'] = $objectData['ValorPagavel'] * $objectData['TaxaMoeda'];
	
	$objectData['TotalEmFalta'] = $objectData['TotalPagar'] - $objectData['TotalLiquidado'];
	$objectData['ValorFalta_Estrangeiro'] = $objectData['TotalEmFalta'] * $objectData['TaxaMoeda'];

	$tempDate = DateTime::createFromFormat('d/m/Y', $objectData['Data']);
	$objectData['DataNormalizada'] = $tempDate->format('Y/m/d');
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM LINHAS MAIN DOCUMENT --------------------------------------------
$objectData['lines'] = array();
$query = "SELECT ID_Recibo, PaymentType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_recibos.ID_Serie) AS Serie, Numero, TransactionDate, GrossTotal, ValorRetencao, Estado FROM faturacao_recibos WHERE ID_DocumentoMain=? AND Tipo_DocumentoMain=? ORDER BY ID_Recibo";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ds", $idFatura, $objectData['InvoiceType']);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ID_Recibo, $tipo_recibo, $serie, $numero, $data_recibo, $total_recibo, $retencao, $estado );
	while ($stmt -> fetch()) {

		$dtReceipt = DateTime::createFromFormat('Y-m-d', $data_recibo);
		$dataReciboProcessed = $dtReceipt->format('d/m/Y');
		
		//Adicionar recibo
		$objectData['lines'][] = array(
		                       		'ID_Recibo' => $ID_Recibo, 
		                       		'Numero' => $tipo_recibo.' '.$serie.'/'.$numero, 
		                       		'Data' => $dataReciboProcessed, 
		                       		'DataNormalizada' => $data_recibo, 
		                       		'Recebido' => $total_recibo, 
		                       		'Retencao' => $retencao, 
		                       		'TotalRecibo' => $total_recibo + $retencao,
		                       		'Estado' => $estado,
		                       	);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM LINHAS MAIN DOCUMENT --------------------------------------------
$objectData['lines_nc'] = array();
$query = "SELECT ID_NotaCredito, InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_credito.ID_Serie) AS Serie, Numero, InvoiceDate, GrossTotal, Estado FROM faturacao_notas_credito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto', 'Pago') ORDER BY ID_NotaCredito";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ds", $idFatura, $objectData['InvoiceType']);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS005";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ID_NotaCredito, $tipo_nota, $serie, $numero, $data_nota, $total_nota, $estado );
	while ($stmt -> fetch()) {

		$dtReceipt = DateTime::createFromFormat('Y-m-d', $data_nota);
		$dataNCProcessed = $dtReceipt->format('d/m/Y');
		
		//Adicionar NC
		$objectData['lines_nc'][] = array(
		                       		'ID_NotaCredito' => $ID_NotaCredito, 
		                       		'Numero' => $tipo_nota.' '.$serie.'/'.$numero, 
		                       		'Data' => $dataNCProcessed, 
		                       		'DataNormalizada' => $data_nota,
		                       		'TotalCreditado' => $total_nota,
		                       		'Estado' => $estado,
		                       	);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS006";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>