<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
$data = "";
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFatura = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFatura == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_Fatura, 
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS Cliente, 
		(SELECT Nif FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS Cliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_faturas.ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_faturas.ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_faturas.ID_Moeda )AS Simbolo, 
		TaxaMoeda,
		(SELECT Vencimento FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente),
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie,  
		Numero, 
		Data, 
		Validade, 
		Referencia, 
		Observacoes, 
		PercentagemDesconto, 
		Estado, 
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_faturas.ID_Utilizador) AS Criador, 
		TimeStampDate, 
		(SELECT Descricao FROM faturacao_metodos_pagamento WHERE faturacao_metodos_pagamento.ID_Metodo = faturacao_faturas.MetodoPagamento) AS MetodoPagamento,
		(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_faturas.ID_Banco) AS Banco,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_faturas.ID_UtilizadorAtualizacao) AS UtilizadorAtualizacao, 
		DataAtualizacao,
		TotalLiquidado,
		GrossTotal,
		Tipo_Doc_Origem,
		ID_Doc_Origem,
		Reference,
		Data_Doc_Origem,
		BVR,
		CASE WHEN datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) <= 0 THEN '' WHEN datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) <=  10 THEN '1º Rappel' ELSE '2º Rappel' END,
		Escompte,
		(SELECT Suspendu FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente),
		PourcentReduc
		FROM faturacao_faturas inner join faturacao_clientes on faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente WHERE ID_Fatura=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Fatura'],
	        	$objectData['Cliente'],
	        	$objectData['Nif'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['Moeda'],
	        	$objectData['IsoCode'],
	        	$objectData['Simbolo'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Vencimento'],
	        	$objectData['Serie'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['Validade'],
	        	$objectData['Referencia'],
	        	$objectData['Observacoes'],
	        	$objectData['PercentagemDesconto'],
	        	$objectData['Estado'],
	        	$objectData['UtilizadorCriador'],
	        	$objectData['DataCriacao'],
	        	$objectData['MetodoPagamento'],
	        	$objectData['Banco'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['TotalLiquidado'],
	        	$objectData['TotalPagar'],
	        	$objectData['Tipo_Doc_Origem'],
	        	$objectData['ID_Doc_Origem'],
	        	$objectData['Reference'],
	        	$objectData['Data_Doc_Origem'],
	        	$objectData['BVR'],
	        	$objectData['Rappel'],
	        	$objectData['Escompte'],
	        	$objectData['Suspendu'],
	        	$objectData['PourcentReduc']
			);
	$stmt -> fetch();
	$stmt -> close();

	$objectData['PaisFull'] = getCountryByISO2($objectData['PaisCliente']);
	$objectData['DataCriacao'] = date('d/m/Y H:i:s', $objectData['DataCriacao']);
	$tempDate = DateTime::createFromFormat('d/m/Y', $objectData['Data']);
	$objectData['DataNormalizada'] = $tempDate->format('Y/m/d');

	//processar totais
	$objectData['TotalLiquidado_Estrangeiro'] = $objectData['TotalLiquidado'] * $objectData['TaxaMoeda'];
	$objectData['TotalPagar_Estrangeiro'] = $objectData['TotalPagar'] * $objectData['TaxaMoeda'];

	//processar BVR
	$bvr_1 = substr($objectData['BVR'], 0, 2);
	$bvr_2 = substr($objectData['BVR'], 2);
	$objectData['BVR'] = $bvr_1 . ' ' . wordwrap($bvr_2, 5, ' ', true);
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//PROCESS ORIGIN IF EXISTS ----------------------------------------------
if($objectData['ID_Doc_Origem'] > 0){
	$fieldIdName = '';
	$tableName = '';
	switch ($objectData['Tipo_Doc_Origem']) {
		case 'GT':
			$fieldIdName = 'ID_GuiaTransporte';
			$tableName = 'faturacao_guias_transporte';
			$selectQuery = 'DataCarga, HoraCarga, DataDescarga, HoraDescarga';
			break;
		case 'CL':
			$fieldIdName = 'ID_Location';
			$tableName = 'faturacao_locations';
			$selectQuery = 'Duree, Debut, Cotisation';
			break;
		case 'CC':
			$fieldIdName = 'ID_Consommable';
			$tableName = 'faturacao_consommables';
			$selectQuery = 'Paiment, Debut';
			break;
		case 'RT':
			$fieldIdName = 'ID_Rapport';
			$tableName = 'faturacao_rapports_travail';
			$selectQuery = 'TotalPagar, Tecnico, Numero';
			break;
		case 'DV':
			$fieldIdName = 'ID_Devis';
			$tableName = 'faturacao_devis';
			$selectQuery = 'TotalPagar, Validade, Estado';
			break;
		case 'LC':
			$fieldIdName = 'ID_Licence';
			$tableName = 'faturacao_licences';
			$selectQuery = 'Duree, Debut';
			break;
		case 'CA':
			$fieldIdName = 'ID_Achat';
			$tableName = 'faturacao_contrats_achats';
			$selectQuery = '(sum(PrixAchat)+sum(PrixInstallation)+sum(PrixPreparation)+sum(PrixTaxeAntecipe)), Debut';
			break;
		
		default:
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS0000AA";
			$response["message"] = 'Tipo inválido!';
			die(json_encode($response));
			break;
	}

	$query = "SELECT ".$selectQuery." FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ( $stmt = $sqli_connection->prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $objectData['ID_Doc_Origem']);
		//result single
		$result = $stmt->execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}

		//result
		switch ($objectData['Tipo_Doc_Origem']) {
			case 'GT':
				$stmt -> bind_result($DataCarga, $HoraCarga, $DataDescarga, $HoraDescarga);
				break;
			case 'CL':
				$stmt -> bind_result($Duree, $Debut, $Cotisation);
				break;
			case 'CC':
				$stmt -> bind_result($Paiment, $Debut);
				break;
			case 'RT':
				$stmt -> bind_result($RT_TotalPagar, $RT_Tecnico, $RT_Numero);
				break;
			case 'DV':
				$stmt -> bind_result($DV_TotalPagar, $DV_Validade, $DV_Estado);
				break;
			case 'LC':
				$stmt -> bind_result($Duree, $Debut);
				break;
			case 'CA':
				$stmt -> bind_result($PrixAchat, $Debut);
				break;
			
			default:
				$stmt -> bind_result();
				break;
		}

		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//GET 
	switch ($objectData['Tipo_Doc_Origem']) {
		case 'GT':
			$objectData['DataCarga'] = $DataCarga.' '.$HoraCarga;
			$objectData['DataDescarga'] = $DataDescarga.' '.$HoraDescarga;
			break;
		case 'CL':
			$objectData['Duree'] = $Duree;
			$objectData['Debut'] = $Debut;
			$objectData['Cotisation'] = $Cotisation;
			break;
		case 'CC':
			$objectData['Paiment'] = $Paiment;
			$objectData['Debut'] = $Debut;
			break;
		case 'RT':
			$objectData['RT_TotalPagar'] = number_format($RT_TotalPagar, 2, '.', '').' CHF';
			$objectData['RT_Tecnico'] = $RT_Tecnico;
			$objectData['RT_Numero'] = $RT_Numero;
			break;
		case 'DV':
			$objectData['DV_TotalPagar'] = number_format($DV_TotalPagar, 2, '.', '').' CHF';
			$objectData['DV_Validade'] = $DV_Validade;
			$objectData['DV_Estado'] = $DV_Estado;
			break;
		case 'LC':
			$objectData['Duree'] = $Duree;
			$objectData['Debut'] = $Debut;
			break;
		case 'CA':
			$objectData['PrixAchat'] = $PrixAchat;
			$objectData['Debut'] = $Debut;
			break;
		
		default:
			$stmt -> bind_result();
			break;
	}

}
//-----------------------------------------------------------------------

//PROCESS AGREGATION IF EXISTS ------------------------------------------
$query = "SELECT InvoiceType, ID_GuiaTransporte,
	CONCAT('BL ', (SELECT faturacao_series.Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_guias_transporte.ID_Serie),'/',faturacao_guias_transporte.Numero),
	Data, CONCAT(DataCarga,' ',HoraCarga), CONCAT(DataDescarga,' ',HoraDescarga)
		FROM faturacao_guias_transporte WHERE Tipo_DocAgregado='FT' AND ID_DocAgregado=? ORDER BY ID_GuiaTransporte";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Tipo_Doc_Agregado, $ID_Doc_Agregado, $Reference_Agregado, $Data_Doc_Agregado, $DataHoraCarga, $DataHoraDescarga );
	while ($stmt -> fetch()) {
		$dataAgregados[] = array(
		        	"Tipo_Doc_Agregado" => $Tipo_Doc_Agregado,
		        	"ID_Doc_Agregado" => $ID_Doc_Agregado,
		        	"Reference_Agregado" => $Reference_Agregado,
		        	"Data_Doc_Agregado" => $Data_Doc_Agregado,
		        	"DataHoraCarga" => $DataHoraCarga,
		        	"DataHoraDescarga" => $DataHoraDescarga,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002A";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['agregados'] = $dataAgregados;

//OBTEM AS LINHAS DA FATURA ------------------------------------------
/*$query = "SELECT (SELECT Codigo FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_faturas_linhas.ID_Artigo) AS Artigo,*/
$query = "SELECT ProductCode,
		Descricao,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		ID_Imposto,
		(SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto) AS Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto) AS ValorIVA,
		(SELECT ID_Motivo FROM faturacao_motivos_isencao WHERE faturacao_motivos_isencao.Codigo = faturacao_faturas_linhas.TaxExemptionCode ) AS ID_Motivo,
		CONCAT(TaxExemptionCode,': ',TaxExemptionReason) AS Motivo,
		DescontoLinha,
		ValorRetencao,
		TotalLinha,
		SerialNumber,
		PlanoContas,
		PlanoContasTVA
		FROM faturacao_faturas_linhas WHERE ID_Fatura=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($artigo, $descricao, $qtd, $unidade, $preco, $idIva, $desc_imposto, $valorIva, $id_motivo, $motivo, $desconto, $retencao, $totalLinha, $serial_number, $PlanoContas, $PlanoContasTVA );
	while ($stmt -> fetch()) {
		$datalin[] = array(
		        	"artigo" => $artigo,
					"descricao" => nl2br($descricao),
					"qtd" => $qtd,
					"unidade" => $unidade,
					"preco" => $preco,
					"idIva" => $idIva,
					"imposto" => number_format($valorIva,2).'%',
					"desc_imposto" => $desc_imposto,
					"valorIva" => $valorIva,
					"id_motivo" => $id_motivo,
					"motivo" => $motivo,
					"desconto" => $desconto,
					"retencao" => $retencao,
					"totalLinha" => $totalLinha,
					"serial_number" => $serial_number,
					"PlanoContas" => $PlanoContas,
					"PlanoContasTVA" => $PlanoContasTVA,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $datalin;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>