<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,729);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDocumento = $_POST['idDocumento'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idDocumento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//VERIFICA SE PODE SER GERADO --------------------------------------------
$query = "SELECT Estado FROM faturacao_locations WHERE ID_Location=?";
if ( $stmt = $sqli_connection->prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt->execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho' ) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Documento inválido para clonar!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DEFINE VARS -----------------------------------------------------------
$objectData = array();

//OBTEM OS Données de Livraison ------------------------------------------------
$query = "SELECT ID_Location, 
		Numero,
		ID_Cliente,
		EnderecoCliente,
		CodigoPostalCliente,
		CidadeCliente,
		RegiaoCliente,
		EmailCliente,
		PaisCliente,
		ID_Vendedor_Primeiro,
		ID_Vendedor_Segundo,
		Data,
		Debut,
		Duree,
		Paiment,
		Referencia,
		Remarque,
		Location_Mensuelle,
		Emolument_Admin,
		TVA_Exclue_Primeiro,
		TVA_Exclue_Segundo,
		Estado,
		DataCriacao,
		ID_Utilizador_Criacao,
		DataAtualizacao,
		ID_Utilizador_Atualizacao,
		Cotisation
		FROM faturacao_locations WHERE ID_Location=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Location'],
	        	$objectData['Numero'],
	        	$objectData['ID_Cliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['ID_Vendedor_Primeiro'],
	        	$objectData['ID_Vendedor_Segundo'],
	        	$objectData['Data'],
	        	$objectData['Debut'],
	        	$objectData['Duree'],
	        	$objectData['Paiment'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Location_Mensuelle'],
	        	$objectData['Emolument_Admin'],
	        	$objectData['TVA_Exclue_Primeiro'],
	        	$objectData['TVA_Exclue_Segundo'],
	        	$objectData['Estado'],
	        	$objectData['DataCriacao'],
	        	$objectData['ID_Utilizador_Criacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['ID_Utilizador_Atualizacao'],
				$objectData['Cotisation']
			);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//PREPARE VARS ----------------------------------------------------------
$timestamp = microtime(true);
$data = date("d/m/Y");
$debut = date("d/m/Y");
$dataCriacao = date("d/m/Y H:i:s");
$utilizadorCriacao = $id_utilizador;
$dataAtualizacao = date("d/m/Y H:i:s");
$utilizadorAtualizacao = $id_utilizador;
$estado = 'Rascunho';
//-----------------------------------------------------------------------

//INSERT OPEN DOCUMENT --------------------------------------------------
$query = "INSERT INTO faturacao_locations (
	ID_Cliente, EnderecoCliente, CodigoPostalCliente, CidadeCliente, RegiaoCliente, 
	EmailCliente, PaisCliente, ID_Vendedor_Primeiro, ID_Vendedor_Segundo, 
	Data, Debut, Duree, Paiment, Referencia, Remarque, Location_Mensuelle, Emolument_Admin, 
	TVA_Exclue_Primeiro, TVA_Exclue_Segundo, Estado, DataCriacao, ID_Utilizador_Criacao, 
	DataAtualizacao, ID_Utilizador_Atualizacao, TimeStamp_Location, Cotisation
	) 
	VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssssssddssssssssssssdsdss",
				$objectData['ID_Cliente'],
				$objectData['EnderecoCliente'],
				$objectData['CodigoPostalCliente'],
				$objectData['CidadeCliente'],
				$objectData['RegiaoCliente'],
				$objectData['EmailCliente'],
				$objectData['PaisCliente'],
				$objectData['ID_Vendedor_Primeiro'],
				$objectData['ID_Vendedor_Segundo'],
				$data,
				$debut,
	        	$objectData['Duree'],
	        	$objectData['Paiment'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Location_Mensuelle'],
	        	$objectData['Emolument_Admin'],
	        	$objectData['TVA_Exclue_Primeiro'],
	        	$objectData['TVA_Exclue_Segundo'],
				$estado,
				$dataCriacao,
				$utilizadorCriacao,
				$dataAtualizacao,
				$utilizadorAtualizacao,
				$timestamp,
				$objectData['Cotisation']
	    	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET DOCUMENT ID
$query = "SELECT ID_Location FROM faturacao_locations WHERE TimeStamp_Location = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("s", $timestamp);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS008";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idLocationNew);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS009";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $idLocationNew < 1){
	$response["errors"] = true;
	$response["type"] = "FATS010";
	$response["message"] = "Location inválida";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET THE LINES ----------------------------------------------------------
$data = array();
$query = "SELECT ID_Location,
			ID_Artigo,
			NumeroLinha,
			ProductCode,
			ProductDescription,
			SerialNumber,
			Quantidade
		FROM faturacao_locations_linhas WHERE ID_Location=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011";
		$response["message"] = $stmt -> error;
		deleteRecord($idLocationNew);
		die(json_encode($response));
	}
	$stmt -> bind_result(
			$ID_Location, 
			$ID_Artigo, 
			$NumeroLinha, 
			$ProductCode, 
			$ProductDescription, 
			$SerialNumber, 
			$Quantidade
		);
	while ($stmt -> fetch()) {
		$datalin[] = array(
		        	"ID_Location" => $ID_Location,
		        	"ID_Artigo" => $ID_Artigo,
		        	"NumeroLinha" => $NumeroLinha,
		        	"ProductCode" => $ProductCode,
		        	"ProductDescription" => $ProductDescription,
		        	"SerialNumber" => $SerialNumber,
		        	"Quantidade" => $Quantidade,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS012";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idLocationNew);
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $datalin;
//------------------------------------------------------------------------

//INSERT THE LINES
foreach ($objectData['linhas'] as $linha) {
	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_locations_linhas (
		ID_Location, ID_Artigo, 
		NumeroLinha, ProductCode, ProductDescription, SerialNumber, Quantidade
		) 
		VALUES (?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddsssd", 
		            $idLocationNew, 
					$linha['ID_Artigo'],
					$linha['NumeroLinha'],
					$linha['ProductCode'],
					$linha['ProductDescription'],
					$linha['SerialNumber'],
					$linha['Quantidade']
				);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS013";
			$response["message"] = $stmt -> error;
			deleteRecord($idLocationNew);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS014";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idLocationNew);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
}


//log sistema - processo
$descricao_log = $data2[729]['trad'].": Contract Location (id: ".$idDocumento.") -- Contract Location (id: ".$idLocationNew.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response["idDestino"] = $idLocationNew;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_locations WHERE ID_Location=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_locations_linhas WHERE ID_Location=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

?>