<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idNota = $_POST['idNota'];
$docOrigem = $_POST['docOrigem'];
$docType = $_POST['docType'];
$cliente = $_POST['cliente'];
$serie = $_POST['serie'];
$numero = $_POST['numero'];
$data = $_POST['data'];
$validade = $_POST['validade'];
$referencia = $_POST['referencia'];
$pagamento = $_POST['pagamento'];
$banco = $_POST['banco'];
$vencimento = $_POST['vencimento'];
$moeda = $_POST['moeda'];
$desconto = $_POST['desconto'];
$observacoes = $_POST['observacoes'];
$motivo = $_POST['motivo'];
$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];
$precisaBanco = $_POST['precisaBanco'];

//REMAIN FIELDS ----------------------------------------------------------
$vendedor = $_SESSION['username'];
$estado = 'Rascunho';
$taxPayable = 0;
$netTotal = 0;
$grossTotal = 0;
$systemEntryDate = '';
$timestamp = 0;
$totalDesconto = 0;
$percentagemDesconto = $desconto;
$retencaoTotal = 0;
$totalSDesconto = 0;

//NEW FIELDS FATURAS -----------------------------------------------------
$invoiceType = 'ND';
$EACCode = '';
$customerID = '';
$totalPagar = 0;
// MetodoPagamento
// BancoID
$invoiceStatusDate = '';
$sourceID = $_SESSION['username'];
$hash = '';
$hashControl = 1;
$hashPrint = '';
$period = '';
$invoiceDate = '';
$movementEndTime = '';
$movementStartTime = '';
$totalLiquidado = 0;

//PROCESS ORIGIN
$fieldIdName = '';
$tableName = '';
switch ($docType) {
	case 'FT':
		$fieldIdName = 'ID_Fatura';
		$tableName = 'faturacao_faturas';
		break;
	case 'FS':
		$fieldIdName = 'ID_FaturaSimplificada';
		$tableName = 'faturacao_faturas_simplificadas';
		break;
	case 'FR':
		$fieldIdName = 'ID_FaturaRecibo';
		$tableName = 'faturacao_faturas_recibo';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000AA";
		$response["message"] = 'Tipo inválido!';
		die(json_encode($response));
		break;
}

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idNota == '' || $idNota < 1 || $docOrigem == '' || $docType == '' || $cliente == '' || $serie == '' || $numero == '' || $data == '' || $validade == '' || $pagamento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
if( $precisaBanco > 0 && ($banco < 1 || $banco == '') )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET REMAINING FIELDS FROM ORIGIN DOC -----------------------------------
$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = ".$tableName.".ID_Serie), Numero, Data, ID_Cliente, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $docOrigem);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000C";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($invoiceTypeOrigin, $serieOrigin, $numeroOrigin, $dataOrigin, $idClienteOrigin, $estadoOrigem );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS0000D";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//contruct final reference
$referenceOrigin = $invoiceTypeOrigin." ".$serieOrigin.'/'.$numeroOrigin;
//------------------------------------------------------------------------

//CHECK IF IS THE SAME CLIENT AND STATUS ALLOWED -------------------------
if( $idClienteOrigin != $cliente )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000E";
	die(json_encode($response));
}
if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000F";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET CLIENT DATA --------------------------------------------------------
$query = "SELECT Nif, Endereco, CodigoPostal, (SELECT Nome FROM concelho WHERE concelho.ID_Concelho = faturacao_clientes.Cidade) AS Cidade, (SELECT Nome FROM distrito WHERE distrito.ID_Distrito = faturacao_clientes.Regiao) AS Regiao, Pais, Email, Codigo FROM faturacao_clientes WHERE ID_Cliente = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Nif, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Email, $CodigoCliente );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//process fields
if( trim($Endereco) == '' ) $Endereco = 'Desconhecido';
if( trim($CodigoPostal) == '' ) $CodigoPostal = 'Desconhecido';
if( trim($Cidade) == '' ) $Cidade = 'Desconhecido';
if( trim($Regiao) == '' ) $Regiao = 'Desconhecido';
if( trim($Pais) == '' ) $Pais = 'Desconhecido';
//------------------------------------------------------------------------

//GET CURRENCY DATA ------------------------------------------------------
$query = "SELECT  Ultima_Taxa FROM faturacao_moedas WHERE ID_Moeda = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ultimaTaxa);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $ultimaTaxa <= 0){
	$response["errors"] = true;
	$response["type"] = "FTGA005";
	$response["message"] = "Moeda inválida";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET COMPANY DATA -------------------------------------------------------
$query = "SELECT  CONCAT(Endereco1,' ',Endereco2) AS Endereco, CodigoPostal, (SELECT Nome FROM concelho WHERE concelho.ID_Concelho = faturacao_empresa_dados.Cidade) AS CIDADENAME, Cidade, CAE_Principal FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
if ($stmt = $sqli_connection -> prepare($query)) {
	// $stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($enderecoCarga, $codigopostalCarga, $cidadeCarga, $idCidadeCarga, $CAE_Principal);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET REGION
$query = "SELECT (SELECT Nome FROM distrito WHERE distrito.ID_Distrito = concelho.ID_Distrito) AS Regiao FROM concelho WHERE ID_Concelho = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idCidadeCarga);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA008";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($regiaoCarga);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA009";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//process fields
if( trim($enderecoCarga) == '' ) $enderecoCarga = 'Desconhecido';
if( trim($codigopostalCarga) == '' ) $codigopostalCarga = 'Desconhecido';
if( trim($cidadeCarga) == '' ) $cidadeCarga = 'Desconhecido';
if( trim($regiaoCarga) == '' ) $regiaoCarga = 'Desconhecido';
//------------------------------------------------------------------------

$timestamp = microtime(true);
$systemEntryDate = date("Y-m-d H:i:s");
$systemEntryDate = str_replace (' ','T',$systemEntryDate);
$EACCode = $CAE_Principal;
$customerID = $CodigoCliente;
if( $precisaBanco > 0 ){
	$bancoFinalID = $banco;
}else{
	$bancoFinalID = 0;
}

//INSERT OPEN DOCUMENT ---------------------------------------------------
$query = "UPDATE faturacao_notas_debito SET ID_Cliente=?, EnderecoCliente=?, CodigoPostalCliente=?, CidadeCliente=?, RegiaoCliente=?, EmailCliente=?, PaisCliente=?, ID_Moeda=?, TaxaMoeda=?, Vendedor=?, Vencimento=?, EnderecoCarga=?, CodigoPostalCarga=?, CidadeCarga=?, RegiaoCarga=?, ID_Serie=?, Data=?, Validade=?, Referencia=?, Observacoes=?, SystemEntryDate=?, TimeStampDate=?, Estado=?, ID_Utilizador=?, InvoiceType=?, EACCode=?, CustomerID=?, MetodoPagamento=?, ID_Banco=?, ID_Documento_Origem=?, Tipo_Documento_Origem=?, Reason_Origem=?, Data_Documento_Origem=?, Reference=? WHERE ID_NotaDebito=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssssssdsssssssdsssssssdsssdddssssd", $cliente, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Email, $Pais, $moeda, $ultimaTaxa, $vendedor, $vencimento, $enderecoCarga, $codigopostalCarga, $cidadeCarga, $regiaoCarga, $serie, $data, $validade, $referencia, $observacoes, $systemEntryDate, $timestamp, $estado, $id_utilizador, $invoiceType, $EACCode, $customerID, $pagamento, $bancoFinalID, $docOrigem, $docType, $motivo, $dataOrigin, $referenceOrigin, $idNota );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA010";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA011";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//CLEAN ALL LINES --------------------------------------------------------
$query = "DELETE FROM faturacao_notas_debito_linhas WHERE ID_NotaDebito=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idNota );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA012";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA013";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//PROCESS LINES ----------------------------------------------------------
$numLinha = 1;
foreach ($linhas as $linha) {
	//init vars
	$ProductDescription = '';
	$ProductCode = '';
	$SerialNumber = '';
	$TaxType = '';
	$TaxCountryRegion = '';
	$TaxCode = '';
	$TaxPercentage = '';
	$impostoUsed = '';
	$TaxExemptionCode = '';
	$TaxExemptionReason = '';
	$TaxPointDate = date("Y-m-d");	

	//GET ARTICLE DATA ---------------------------------------------------
	$query = "SELECT  Nome, Codigo, SerialNumber, (SELECT Sigla FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade = faturacao_artigos.ID_Unidade) AS Unidade FROM faturacao_artigos WHERE ID_Artigo = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA015";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> bind_result($ProductDescription, $ProductCode, $SerialNumber, $Unidade);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA016";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	//GET TAXES DATA -----------------------------------------------------
	$query = "SELECT  Tipo, Regiao, Subclasse, Valor FROM faturacao_impostos WHERE ID_Imposto = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['imposto']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA017";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> bind_result($TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA018";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
		//VERIFICAR SE IMPOSTO JÁ BLOQUEADO -------------------------------------
		$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $linha['imposto']);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018A";
				$response["message"] = $stmt -> error;
				deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($impostoUsed);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA018B";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		if($impostoUsed < 1){
			//INSERT DB --------------------------------------------------
			$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("d", $linha['imposto'] );
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA018C";
					$response["message"] = $stmt -> error;
					deleteRecord($idNota);
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018D";
				$response["message"] = $sqli_connection -> error;
				deleteRecord($idNota);
				die(json_encode($response));
			}
			//------------------------------------------------------------
		}

		//CASO SEJA TIPO ISE
		// if( $TaxCode == 'ISE' ){
		if( $TaxCode == 'ISENTO' ){
			if( $linha['motivo'] < 1){
				$response["errors"] = true;
				$response["type"] = "var";
				$response["line"] = "FTGA018E";
				$response["message"] = "Motivo de isenção inválido";
				deleteRecord($idNota);
				die(json_encode($response));
			}else{
				$query = "SELECT  Codigo, Descricao FROM faturacao_motivos_isencao WHERE ID_Motivo = ?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("d", $linha['motivo']);
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "FTGA018F";
						$response["message"] = $stmt -> error;
						deleteRecord($idNota);
						die(json_encode($response));
					}
					$stmt -> bind_result($TaxExemptionCode, $TaxExemptionReason);
					$stmt -> fetch();
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "FTGA018G";
					$response["message"] = $sqli_connection -> error;
					deleteRecord($idNota);
					die(json_encode($response));
				}
			}

		}
	//--------------------------------------------------------------------
	
	//check if vals are smaller than 0
	if( $linha['qtd'] <= 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018H";
		$response["message"] = 'Valores das linhas menores que 0';
		deleteRecord($idNota);
		die(json_encode($response));
	}
	if( $linha['preco'] < 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018I";
		$response["message"] = 'Valores das linhas menores que 0';
		deleteRecord($idNota);
		die(json_encode($response));
	}
	
	//TOTALS
	$debitAmount = 0;
	$creditAmount = 0;
	$settelementAmount = 0;
	$totalSIVA = 0;
	$totalLinha = 0;

	$linhaDesconto = $linha['desconto'] * 0.01;
	$descontoProcessed = $desconto * 0.01;
	$taxaIVA = $TaxPercentage * 0.01;
	$ivaProcessed = $taxaIVA + 1 ;

	$totalSIVA = $linha['qtd'] * $linha['preco'];
	$desconto1 = $totalSIVA * $linhaDesconto; //calcula desconto 1
	$totalSIVA = $totalSIVA - ($totalSIVA * $linhaDesconto); //calcula descunto linha
	$desconto2 = $totalSIVA * $descontoProcessed; //calcula desconto 2
	$totalSIVA = $totalSIVA - ($totalSIVA * $descontoProcessed); //calcula desconto global

	$settelementAmount = $desconto1 + $desconto2;
	$creditAmount = $totalSIVA;
	$totalLinha = $totalSIVA * $ivaProcessed;

	$retencao = $linha['retencao'] * 0.01;
	$retencao = $totalSIVA * $retencao;

	//TOTALS DOCUMENT
	$taxPayable = $taxPayable + ($totalSIVA * $taxaIVA);
	$netTotal = $netTotal + $totalSIVA;
	$grossTotal = $taxPayable + $netTotal;
	// $grossTotal = round($grossTotal,2);
	$totalDesconto = $totalDesconto + $settelementAmount;
	if( $Nif != '999999990' ) $retencaoTotal = $retencaoTotal + $retencao;
	$totalSDesconto = $totalSDesconto + ( $linha['qtd'] * $linha['preco'] );

	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_notas_debito_linhas (ID_NotaDebito, NumeroLinha, 
		ID_Artigo, ProductCode, ProductDescription, Quantidade, UnidadeMedida, PrecoUnitario, TaxPointDate, Descricao, SerialNumber, 
		ID_Imposto, TaxType, TaxCountryRegion, TaxCode, TaxPercentage, TaxExemptionReason, TaxExemptionCode, 
		DescontoLinha, CreditAmount, DebitAmount, SettlementAmount, ValorRetencao, PercentagemRetencao, TotalLinha, TotalLinhaSIVA) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssss", $idNota, $numLinha, $linha['artigo'], $ProductCode, $ProductDescription, $linha['qtd'], $Unidade, $linha['preco'], $TaxPointDate, $linha['descricao'], $SerialNumber, $linha['imposto'], $TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage, $TaxExemptionReason, $TaxExemptionCode, $linha['desconto'], $creditAmount, $debitAmount, $settelementAmount, $retencao, $linha['retencao'], $totalLinha, $totalSIVA );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA019";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	$numLinha++;

	//BLOCK ARTICLE ------------------------------------------------------
	$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020A";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020B";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
}
//------------------------------------------------------------------------

//UPDATES TOTALS ---------------------------------------------------------
$totalDesconto = round($totalDesconto,$numDecimais);
$retencaoTotal = round($retencaoTotal,$numDecimais);
$taxPayable = round($taxPayable,$numDecimais);
$netTotal = round($netTotal,$numDecimais);
$grossTotal = round($grossTotal,$numDecimais);
$totalPagar = $grossTotal;

$query = "UPDATE faturacao_notas_debito SET TaxPayable=?, NetTotal=?, GrossTotal=?, Desconto=?, PercentagemDesconto=?, TotaRetencao=?, TotalSDesconto=?, TotalPagar=?, Data_Documento_Origem=?, Reference=? WHERE ID_NotaDebito=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssssssssssd", $taxPayable, $netTotal, $grossTotal, $totalDesconto, $percentagemDesconto, $retencaoTotal, $totalSDesconto, $totalPagar, $dataOrigin, $referenceOrigin, $idNota);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA021C";
		$response["message"] = $stmt -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA022";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idNota);
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
if( $finalizarDocumento > 0 ){
	$systemEntryDateUpdate = date("Y-m-d H:i:s");
	$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
	$invoiceStatusDate = date("Y-m-d H:i:s");
	$invoiceStatusDate = str_replace (' ','T',$invoiceStatusDate);
	$sourceID = $_SESSION['username'];
	$hash = 'TESTE';
	$hashControl = 1;
	$hashPrint = 'ABCD';
	$movementEndTime = '';
	// $retencaoCalc = round($retencaoTotal,2);
	$retencaoCalc = $retencaoTotal;
	// $totalLiquidado = $retencaoCalc;
	$totalLiquidado = 0;

	$dataNew = $data;
	$validadeNew = $validade;
	$dataAtualizacao = date("d/m/Y H:i:s");
	
	//process InvoiceDate and period to the choosen one
	$tempDate = DateTime::createFromFormat('d/m/Y', $data);
	$invoiceDate = $tempDate->format('Y-m-d');
	$period = $tempDate->format('m');
	//define start time
	$movementStartTime = $tempDate->format("Y-m-d H:i:s");
	$movementStartTime = str_replace (' ','T',$movementStartTime);


	//GET LAST DATE
	$query = "SELECT MAX(Numero), Data FROM faturacao_notas_debito WHERE ID_Serie = ? AND Numero > 0";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $serie);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA023";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> bind_result($numMax, $dataLast);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA024";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
	if( $numMax > 0){
		//this entry date timestamp
		$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
		$dtOriginDateTime = $dtOriginDate->getTimestamp();

		//last date timestamp
		$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
		$dtLastTime = $dtLast->getTimestamp();

		//this entry validade timestamp
		$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
		$dtThisValidadeTime = $dtThisValidade->getTimestamp();

		//this entry date timestamp
		$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
		$dtThisDateTime = $dtThisDate->getTimestamp();

		//process new dates
		if( $dtThisDateTime < $dtLastTime ){
			// $dataNew = $dataLast;
			// //update invoiceDate and period
			// $invoiceDate = date("Y-m-d");
			// $period = date("m");
			// //define start time
			// $movementStartTime = date("Y-m-d H:i:s");
			// $movementStartTime = str_replace (' ','T',$movementStartTime);
			
			//alert user that the date is before the last one
			$response["errors"] = true;
			$response["type"] = "FTGA024A";
			$response["data_superior"] = true;
			$response["dataUltima"] = $dataLast;
			$response["message"] = "Data superior à última nota.";
			deleteRecord($idNota);
			die(json_encode($response));
		}
		//process date origin
		if( $dtThisDateTime < $dtOriginDateTime ){
			//alert user that the date is before the last one
			$response["errors"] = true;
			$response["type"] = "FTGA024B";
			$response["data_superior2"] = true;
			$response["dataUltima"] = $dataOrigin;
			$response["message"] = "Data superior à última fatura.";
			deleteRecord($idNota);
			die(json_encode($response));
		}

		if( $dtThisValidadeTime < $dtThisDateTime ){
			$validadeNew = $data;
		}
	}else{
		//this entry date timestamp
		$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
		$dtOriginDateTime = $dtOriginDate->getTimestamp();

		//this entry date timestamp
		$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
		$dtThisDateTime = $dtThisDate->getTimestamp();

		//process date origin
		if( $dtThisDateTime < $dtOriginDateTime ){
			//alert user that the date is before the last one
			$response["errors"] = true;
			$response["type"] = "FTGA024C";
			$response["data_superior2"] = true;
			$response["dataUltima"] = $dataOrigin;
			$response["message"] = "Data superior à última fatura.";
			deleteRecord($idNota);
			die(json_encode($response));
		}
	}



	// DEFINE NEW NUMBER
	$query = "UPDATE faturacao_notas_debito SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_notas_debito WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_NotaDebito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idNota);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}

	// UPDATE REMAIN FIELDS
	$query = "UPDATE faturacao_notas_debito SET InvoiceStatusDate=?, SourceID=?, Hash=?, HashControl=?, Hash_Print=?, Period=?, InvoiceDate=?, MovementEndTime=?, MovementStartTime=?, TotalLiquidado=?, SystemEntryDate=? WHERE ID_NotaDebito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssdsssssssd", $invoiceStatusDate, $sourceID, $hash, $hashControl, $hashPrint, $period, $invoiceDate, $movementEndTime, $movementStartTime, $totalLiquidado, $systemEntryDateUpdate, $idNota );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
	// UPDATE REMAIN FIELDS LINES
	$query = "UPDATE faturacao_notas_debito_linhas SET TaxPointDate=? WHERE ID_NotaDebito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sd", $invoiceDate, $idNota );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026A";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026B";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}

	//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
	$query = "SELECT TotalPagar, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026C";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> bind_result($totalPagarOrigem, $estadoOrigemLast );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026D";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		die(json_encode($response));
	}
	//last check on estado
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FTGA026E";
		deleteRecord($idNota);
		die(json_encode($response));
	}else{
		###---- UPDATE DOC ORIGEM ----###
		$totalPagarOrigemNovo = $totalPagarOrigem + $totalPagar;
		$estadoNovo = 'Aberto';
		$query = "UPDATE ".$tableName." SET TotalPagar=?, Estado=? WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ssd", $totalPagarOrigemNovo, $estadoNovo, $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA026F";
				$response["message"] = $stmt -> error;
				deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026G";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idNota);
			die(json_encode($response));
		}
	}
	//--------------------------------------------------------------------
	
	//UPDATE STOCKS
	/* Le stock ne doit etre update qu'avec les factures
	$stockUpdateResult = decreaseArticlesStock($idNota, 'faturacao_notas_debito', 'ID_NotaDebito');
	if($stockUpdateResult != true){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = 'Falha ao atualizar stocks.';
		die(json_encode($response));
	}
}else{
	$response["nota"] = $idNota;
}*/
//------------------------------------------------------------------------

//BLOCK CLIENT ----------------------------------------------------------
$query = "UPDATE faturacao_clientes SET Usado=1 WHERE ID_Cliente=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = $stmt -> error;
		deleteRecord($idNota);
		recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA028";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idNota);
	recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
	die(json_encode($response));
}
//------------------------------------------------------------------------

//BLOCK BANK ----------------------------------------------------------
$query = "UPDATE faturacao_bancos SET Usado=1 WHERE ID_Banco=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $bancoFinalID);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA029";
		$response["message"] = $stmt -> error;
		deleteRecord($idNota);
		recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA030";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idNota);
	recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
	die(json_encode($response));
}
//------------------------------------------------------------------------

//INSERT NEW MOTIVE IF NOT INSERTED YET ----------------------------------
$query = "SELECT COUNT(*) FROM faturacao_motivos_notas WHERE Descricao LIKE '%".$motivo."%'";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA031";
			$response["message"] = $stmt -> error;
			deleteRecord($idNota);
			recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
			die(json_encode($response));
		}
		$stmt -> bind_result( $counterMotives );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA032";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idNota);
		recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
		die(json_encode($response));
	}
	if( $counterMotives < 1 ){
		$query = "INSERT INTO faturacao_motivos_notas (Descricao) VALUES (?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("s", $motivo );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA033";
				$response["message"] = $stmt -> error;
				deleteRecord($idNota);
				recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA034";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idNota);
			recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
			die(json_encode($response));
		}
	}
//------------------------------------------------------------------------


//response
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_notas_debito WHERE ID_NotaDebito=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_notas_debito_linhas WHERE ID_NotaDebito=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

//Recalculate Totals for origin Document
function recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName){
	global $sqli_connection;
	$totalPagarNew = 0;
	//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
	$query = "SELECT TotalLiquidado, GrossTotal, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalLiquidadoOrigem, $totalGrossOrigem, $estadoOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//last check on estado
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "REM007";
		die(json_encode($response));
	}else{
		//GET ND TOTALS -----------------------------
		$query = "SELECT SUM(GrossTotal) FROM faturacao_notas_debito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($sumGrossND );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		$totalPagarNew = $totalGrossOrigem + $sumGrossND;

		//round numbers
		$totalLiquidadoOrigem = round($totalLiquidadoOrigem,$numDecimais);
		$totalPagarNew = round($totalPagarNew,$numDecimais);

		$estadoNovo = 'Aberto';
		if( $totalLiquidadoOrigem < $totalPagarNew){
			$estadoNovo = 'Aberto';
		}elseif( $totalLiquidadoOrigem = $totalPagarNew){
			$estadoNovo = 'Pago';
		}else{
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$query = "UPDATE ".$tableName." SET TotalPagar=?, Estado=? WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ssd", $totalPagarNew, $estadoNovo, $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM011";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM011";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
	//--------------------------------------------------------------------
}
?>