<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idOrcamento = $_POST['idOrcamento'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idOrcamento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Data, DataValidade, ID_Serie FROM faturacao_orcamentos WHERE ID_Orcamento=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idOrcamento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $data, $validade, $serie);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado != 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "usado";
	$response["line"] = "FATS003";
	$response["message"] = "Orçamento já finalizado!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
$dataNew = $data;
$validadeNew = $validade;
$dataAtualizacao = date("d/m/Y H:i:s");


//GET LAST DATE
$query = "SELECT MAX(Numero), Data FROM faturacao_orcamentos WHERE ID_Serie = ? AND Numero > 0";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $serie);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA023";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($numMax, $dataLast);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA024";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $numMax > 0){
	//last date timestamp
	$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
	$dtLastTime = $dtLast->getTimestamp();

	//this entry date timestamp
	$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
	$dtThisDateTime = $dtThisDate->getTimestamp();
	//this entry validade timestamp
	$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
	$dtThisValidadeTime = $dtThisValidade->getTimestamp();

	//process new dates
	if( $dtThisDateTime < $dtLastTime ){
		$dataNew = $dataLast;
	}
	if( $dtThisValidadeTime < $dtLastTime ){
		$validadeNew = $dataLast;
	}
}

// DEFINE NEW NUMBER
$query = "UPDATE faturacao_orcamentos SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_orcamentos WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, DataValidade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_Orcamento = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idOrcamento);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA025";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));
?>