<?php 
$rolesPermsFile = true;

$currUser = $_SESSION['id_utilizador'];

/**
 * Get CurrentUser Role(s)
 * @return role ID
 */
function getCurrentUserRole(){
	global $sqli_connection;
	global $currUser;

	//process
	$query = "SELECT ID_Permissao FROM utilizador WHERE ID_Utilizador = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $currUser);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($administrador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//return next id
	return $administrador;
}

/**
 * Get the Next ID for table
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function adminCheckerNew($userID){
	global $sqli_connection;
	//process
	$query = "SELECT AdministradorFaturacao FROM utilizador WHERE ID_Utilizador = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $userID);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($administrador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//return next id
	return $administrador;
}

/**
 * Check if has specific permission
 * @param  $perm code
 * @return boolean
 */
function hasPermission($machineName){
	global $sqli_connection;
	global $currUser;

	//check type and adminchecker to return right away
	if($_SESSION['tipo_utilizador'] == 1 || adminCheckerNew($_SESSION['id_utilizador']) == 1 ) return 1;

	//get user role
	$roleID = getCurrentUserRole();
	$machineName = str_replace("P","",$machineName);
	
	//prepare vars for the query
	$checkArray = is_array($machineName);

	//process
	if($checkArray == true) {
		$machineName = implode(",",$machineName);
		$query = "SELECT COUNT(*) FROM faturacao_role_permission, faturacao_permissions WHERE ID_Role_Rel = ? AND ID_Permission_Rel = ID_Permission AND Machine_Name IN (".$machineName.")";
	}else {
		$query = "SELECT COUNT(*) FROM faturacao_role_permission, faturacao_permissions WHERE ID_Role_Rel = ? AND ID_Permission_Rel = ID_Permission AND Machine_Name = ".$machineName."";
	}
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $roleID);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000AA";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counter);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000BB";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//process bool
	$hasPerm = 0;
	if($counter > 0) $hasPerm = 1;

	//return next id
	// var_dump($hasPerm);
	return $hasPerm;
}


/**
 * Check if has the sallesmen permission
 * @return boolean
 */
function isVendedor(){
	global $sqli_connection;
	global $currUser;

	$machineName = 'P0104';

	//check type and adminchecker to return right away
	if($_SESSION['tipo_utilizador'] == 1 || adminCheckerNew($_SESSION['id_utilizador']) == 1 ) return 0;

	//get user role
	$roleID = getCurrentUserRole();
	$machineName = str_replace("P","",$machineName);
	
	//prepare vars for the query
	$checkArray = is_array($machineName);

	//process
	if($checkArray == true) {
		$machineName = implode(",",$machineName);
		$query = "SELECT COUNT(*) FROM faturacao_role_permission, faturacao_permissions WHERE ID_Role_Rel = ? AND ID_Permission_Rel = ID_Permission AND Machine_Name IN (".$machineName.")";
	}else {
		$query = "SELECT COUNT(*) FROM faturacao_role_permission, faturacao_permissions WHERE ID_Role_Rel = ? AND ID_Permission_Rel = ID_Permission AND Machine_Name = ".$machineName."";
	}
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $roleID);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000CC";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counter);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000DD";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//process bool
	$hasPerm = 0;
	if($counter > 0) $hasPerm = 1;

	//return next id
	// var_dump($hasPerm);
	return $hasPerm;
}

/**
 * get the clients for this saller
 * @return boolean
 */
function getVendedorClients(){
	global $sqli_connection;
	global $currUser;

	$idsClientes = "";
	$tmp_cliente = "";
	$idvendedor = '';

	$dataTemp = array();

	$query = "SELECT ID_Vendedor FROM utilizador, faturacao_vendedores WHERE ID_Utilizador = ? AND CodigoInternoVendedor = Codigo_Interno";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $currUser);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($idvendedor);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	if($idvendedor > 0 && $idvendedor != '' && $idvendedor != null){
		$query2 = "SELECT ID_Cliente_Rel FROM faturacao_cliente_vendedor WHERE ID_Vendedor_Rel = ?";
		if ( $stmt2 = $sqli_connection -> prepare($query2) ) {
			$stmt2 -> bind_param("s", $idvendedor);
			//result
			$result = $stmt2 -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP000A";
				$response["message"] = $stmt2 -> error;
				die(json_encode($response));
			}
			$stmt2 -> store_result();
			$stmt2 -> bind_result($tmp_cliente);
			while($stmt2 -> fetch() ){
				$dataTemp[] = $tmp_cliente;
			}
			$stmt2 -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP000B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
	//ajouter les ids des sportifs?
	/*$query3 = "SELECT ID_Cliente FROM faturacao_clientes WHERE Role is not null";
		if ( $stmt3 = $sqli_connection -> prepare($query3) ) {
			//result
			$result = $stmt3 -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP000S";
				$response["message"] = $stmt3 -> error;
				die(json_encode($response));
			}
			$stmt3 -> store_result();
			$stmt3 -> bind_result($sportif_id);
			while($stmt3 -> fetch() ){
				$dataTemp[] = $sportif_id;
			}
			$stmt3 -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP001S";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}*/

	$idsClientes = implode(',', $dataTemp);

	return $idsClientes;
}

/**
 * Get the current user internal code
 * @return user internal code
 */
function getUserInternalCode(){
	global $sqli_connection;
	global $currUser;
	
	$internalCode = '';

	$query = "SELECT CodigoInternoVendedor FROM utilizador WHERE ID_Utilizador = ? ";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $currUser);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($internalCode);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	return $internalCode;
}

?>