<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idCodepostal = $_POST['idCodepostal'];
$descricao_codepostal = $_POST['descricao_codepostal'];
$code_codepostal = $_POST['code_codepostal'];

if ( $idCodepostal == '' || $idCodepostal < 1 || $descricao_codepostal == '' || $code_codepostal == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);


	//SELECT PREVIOUS STATE ----------------------------------------
	$query = "SELECT npa, localite FROM faturacao_npa_localites WHERE id=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCodepostal);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $NPA, $Localite );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//PROCESS
	$query = "UPDATE faturacao_npa_localites SET npa=?, localite=? WHERE id=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssd", $code_codepostal, $descricao_codepostal, $idCodepostal );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-------------------------------------------------------------


	//log sistema -------------------------------------------------------
	$descricao_log ="Code Postal (NPA): Édition (".$NPA." - ".$Localite." >> ".$code_codepostal." - ".$descricao_codepostal.")";
	insert_log(14,"Editar",$descricao_log,$sqli_connection);

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
die(json_encode($response));
?>