<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idUnidade = $_POST['idUnidade'];

if ( $idUnidade == '' || $idUnidade < 1 ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}
	
//VERIFY MIN ID -----------------------------------------------
if($idUnidade < 8){
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS000A";
	$response["sistema"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-------------------------------------------------------------

//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);


	//SELECT PREVIOUS STATE ----------------------------------------
	$query = "SELECT Descricao, Sigla, Ativo FROM faturacao_unidades WHERE ID_Unidade=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idUnidade);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $Descricao, $Sigla, $Ativo );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//SELECT DB ---------------------------------------------------
	$Used = null;
	$query = "SELECT COUNT(*) FROM faturacao_artigos WHERE ID_Unidade=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idUnidade);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $Used );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-------------------------------------------------------------

	//PROCESS
	if($Used < 1){
		//DELETE DB -----------------------------------------------
		$query = "DELETE FROM faturacao_unidades WHERE ID_Unidade=?";

		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $idUnidade );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS009";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS010";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//----------------------------------------------------------
	}else{
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011";
		$response["bloqued"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-------------------------------------------------------------


	//log sistema -------------------------------------------------------
	$descricao_log ="Unité de Mesure: Supprimer (".$Descricao." - ".$Sigla.")";
	insert_log(14,"Apagar",$descricao_log,$sqli_connection);

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
die(json_encode($response));
?>