<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |						Clients Actions - API
 * |
 * |-----------------------------------------------------------------------
 */
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/auth/controltoken.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/processor.php";

//GLOBAL VARS -----------------------------------------------------------
$opcao = $gOpcaoProcessor;
$baseLnk = getBaseLink();
$api_path = getApiPath();
$webservices_path = getWebservicesPath();
$_tokenRequest = $recToken;
//-----------------------------------------------------------------------

//GET POST VARS ---------------------------------------------------------
switch ($opcao) {
	case 0:
		//GET ALL CLIENTS (AJAX)
		$search = $_GET['search'];
		$idclient = $_GET['idclient']; /*DON'T USE FOR NOW*/
		$page = $_GET['page'];

		getAllClients($search, $idclient, $page);
		//---------------------------------
		break;

	case 1:
		//GET CLIENTS DETAILS
		$idclient = $_GET['idclient'];

		getClientDetails($idclient);
		//---------------------------------
		break;

	case 2:
		//ADD CLIENT
		$receivedData = $_POST;

		addClient($receivedData);
		//---------------------------------
		break;

	case 3:
		//EDIT CLIENT
		$receivedData = $_PUT;

		editClient($receivedData);
		//---------------------------------
		break;

	case 4:
		//DELETE CLIENT
		$receivedData = $_DELETE;

		deleteClient($receivedData);
		//---------------------------------
		break;

	default:
		//CANCEL THE REQUEST
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 400 Bad Request.');
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "WAPI_VAR001";
		$response["message"] = 'Invalid option received. Please provide a valid option.';
		die(json_encode($response));
		//---------------------------------
		break;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------

//GET ALL CLIENTS -------------------------------------------------------
function getAllClients($search, $idclient, $page){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/combobox/vendas_select2_ajax.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/combobox/vendas_select2_ajax.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"opcao" => 10,
		"search_term" => $search ? $search : null,
		"search_idcliente" => $idclient ? $idclient : null,
		"page" => $page ? $page : 1,
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

//GET DETAILS CLIENT ----------------------------------------------------
function getClientDetails($idclient){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/clientes/ws_detalhes.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/clientes/ws_detalhes.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"idCliente" => $idclient,
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

//ADD CLIENT ------------------------------------------------------------
function addClient($dataToProcess){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/clientes/ws_inserir.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/clientes/ws_inserir.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		// "idCliente" => $dataToProcess['idclient'],
		"nome_cliente" => $dataToProcess['name'],
		"apelido_cliente" => $dataToProcess['surname'],
		"nif_cliente" => '',
		"titulo_cliente" => $dataToProcess['title'],
		"pais_cliente" => $dataToProcess['country'],
		"endereco_cliente" => $dataToProcess['address'],
		"codigopostal_cliente" => $dataToProcess['postalcode'],
		"regiao_cliente" => '',
		"cidade_cliente" => $dataToProcess['localite'],
		"vendedor_cliente" => json_encode( $dataToProcess['vendeurs'] ),
		"responsavel_cliente" => $dataToProcess['responsible'],
		"email_cliente" => $dataToProcess['email'],
		"website_cliente" => $dataToProcess['website'],
		"tlm_cliente" => $dataToProcess['phone'],
		"tlf_cliente" => '',
		"fax_cliente" => '',
		"preferencial_nome_cliente" => '',
		"preferencial_email_cliente" => '',
		"preferencial_tlm_cliente" => '',
		"preferencial_tlf_cliente" => '',
		"pagamento_cliente" => $dataToProcess['payment_method'],
		"vencimento_Cliente" => $dataToProcess['payment_conditions'],
		"desconto_cliente" => $dataToProcess['discount'],
		"flagContaGeral" => 1,
		"plano_cliente" => $dataToProcess['plan_comptable'],
		"nome_responsavel_1" => $dataToProcess['name_responsible_1'],
		"prenom_responsavel_1" => $dataToProcess['surname_responsible_1'],
		"email_responsavel_1" => $dataToProcess['email_responsible_1'],
		"contacto_responsavel_1" => $dataToProcess['phone_responsible_1'],
		"nome_responsavel_2" => $dataToProcess['name_responsible_2'],
		"prenom_responsavel_2" => $dataToProcess['surname_responsible_2'],
		"email_responsavel_2" => $dataToProcess['email_responsible_2'],
		"contacto_responsavel_2" => $dataToProcess['phone_responsible_2'],
		"nome_responsavel_3" => $dataToProcess['name_responsible_3'],
		"prenom_responsavel_3" => $dataToProcess['surname_responsible_3'],
		"email_responsavel_3" => $dataToProcess['email_responsible_3'],
		"contacto_responsavel_3" => $dataToProcess['phone_responsible_3'],
		"nome_responsavel_4" => $dataToProcess['name_responsible_4'],
		"prenom_responsavel_4" => $dataToProcess['surname_responsible_4'],
		"email_responsavel_4" => $dataToProcess['email_responsible_4'],
		"contacto_responsavel_4" => $dataToProcess['phone_responsible_4'],
		"nome_responsavel_5" => $dataToProcess['name_responsible_5'],
		"prenom_responsavel_5" => $dataToProcess['surname_responsible_5'],
		"email_responsavel_5" => $dataToProcess['email_responsible_5'],
		"contacto_responsavel_5" => $dataToProcess['phone_responsible_5'],
		"nome_responsavel_6" => $dataToProcess['name_responsible_6'],
		"prenom_responsavel_6" => $dataToProcess['surname_responsible_6'],
		"email_responsavel_6" => $dataToProcess['email_responsible_6'],
		"contacto_responsavel_6" => $dataToProcess['phone_responsible_6'],
		"nome_responsavel_7" => $dataToProcess['name_responsible_7'],
		"prenom_responsavel_7" => $dataToProcess['surname_responsible_7'],
		"email_responsavel_7" => $dataToProcess['email_responsible_7'],
		"contacto_responsavel_7" => $dataToProcess['phone_responsible_7'],
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

//EDIT CLIENT -----------------------------------------------------------
function editClient($dataToProcess){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/clientes/ws_editar.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/clientes/ws_editar.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"idCliente" => $dataToProcess['idclient'],
		"nome_cliente" => $dataToProcess['name'],
		"apelido_cliente" => $dataToProcess['surname'],
		"nif_cliente" => '',
		"titulo_cliente" => $dataToProcess['title'],
		"pais_cliente" => $dataToProcess['country'],
		"endereco_cliente" => $dataToProcess['address'],
		"codigopostal_cliente" => $dataToProcess['postalcode'],
		"regiao_cliente" => '',
		"cidade_cliente" => $dataToProcess['localite'],
		"vendedor_cliente" => json_encode( $dataToProcess['vendeurs'] ),
		"responsavel_cliente" => $dataToProcess['responsible'],
		"email_cliente" => $dataToProcess['email'],
		"website_cliente" => $dataToProcess['website'],
		"tlm_cliente" => $dataToProcess['phone'],
		"tlf_cliente" => '',
		"fax_cliente" => '',
		"preferencial_nome_cliente" => '',
		"preferencial_email_cliente" => '',
		"preferencial_tlm_cliente" => '',
		"preferencial_tlf_cliente" => '',
		"pagamento_cliente" => $dataToProcess['payment_method'],
		"vencimento_Cliente" => $dataToProcess['payment_conditions'],
		"desconto_cliente" => $dataToProcess['discount'],
		"flagContaGeral" => 1,
		"plano_cliente" => $dataToProcess['plan_comptable'],
		"nome_responsavel_1" => $dataToProcess['name_responsible_1'],
		"prenom_responsavel_1" => $dataToProcess['surname_responsible_1'],
		"email_responsavel_1" => $dataToProcess['email_responsible_1'],
		"contacto_responsavel_1" => $dataToProcess['phone_responsible_1'],
		"nome_responsavel_2" => $dataToProcess['name_responsible_2'],
		"prenom_responsavel_2" => $dataToProcess['surname_responsible_2'],
		"email_responsavel_2" => $dataToProcess['email_responsible_2'],
		"contacto_responsavel_2" => $dataToProcess['phone_responsible_2'],
		"nome_responsavel_3" => $dataToProcess['name_responsible_3'],
		"prenom_responsavel_3" => $dataToProcess['surname_responsible_3'],
		"email_responsavel_3" => $dataToProcess['email_responsible_3'],
		"contacto_responsavel_3" => $dataToProcess['phone_responsible_3'],
		"nome_responsavel_4" => $dataToProcess['name_responsible_4'],
		"prenom_responsavel_4" => $dataToProcess['surname_responsible_4'],
		"email_responsavel_4" => $dataToProcess['email_responsible_4'],
		"contacto_responsavel_4" => $dataToProcess['phone_responsible_4'],
		"nome_responsavel_5" => $dataToProcess['name_responsible_5'],
		"prenom_responsavel_5" => $dataToProcess['surname_responsible_5'],
		"email_responsavel_5" => $dataToProcess['email_responsible_5'],
		"contacto_responsavel_5" => $dataToProcess['phone_responsible_5'],
		"nome_responsavel_6" => $dataToProcess['name_responsible_6'],
		"prenom_responsavel_6" => $dataToProcess['surname_responsible_6'],
		"email_responsavel_6" => $dataToProcess['email_responsible_6'],
		"contacto_responsavel_6" => $dataToProcess['phone_responsible_6'],
		"nome_responsavel_7" => $dataToProcess['name_responsible_7'],
		"prenom_responsavel_7" => $dataToProcess['surname_responsible_7'],
		"email_responsavel_7" => $dataToProcess['email_responsible_7'],
		"contacto_responsavel_7" => $dataToProcess['phone_responsible_7'],
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

//EDIT CLIENT -----------------------------------------------------------
function deleteClient($dataToProcess){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/clientes/ws_apagar.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/clientes/ws_apagar.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"idCliente" => $dataToProcess['idclient'],
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

?>