<?php
// header("Content-Type: text/plain; charset=utf-8");

//requires the 'php5enmod imap' module on server
//ubuntu - apt-get install php5-imap - sudo php5enmod imap - sudo service apache2 restart
//centOS - sudo php5enmod imap
//---------- MAIL SERVERS -----------
/*
 Gmail {imap.gmail.com:993/imap/ssl}INBOX
 Office365/Hotmail {outlook.office365.com:993/imap/ssl}INBOX
 Yahoo {imap.mail.yahoo.com:993/imap/ssl}INBOX
 AOL {imap.aol.com:993/imap/ssl}INBOX
 NO TLS {<server>/notls} --> When Port 143 (Our Servers)
 INVALID CERTIFICATE {<server>/ssl/novalidate-cert} --> When Port 993 (Our Servers)
 */
$global_array_att = array();
/**
 * Get the MailBox Connection
 * @return [type] [description]
 */
function mailBoxConnection($folder = '') {
	//connection vars
	include "connection.php";

	if ($folder != '' && $folder != 'INBOX') {
		$folderToUse = $folderSent;
	} else {
		$folderToUse = $folderInbox;
	}

	//connect
	$mailbox = imap_open("{" . $server . "}" . $folderToUse, $user, $pass);

	//check if failed
	if (!$mailbox) {
		return false;
	}

	//return connection
	return $mailbox;
}

/**
 * Get Emails List for use in a table or list
 * @return emails and totals
 */
function getEmailsList($folder = '') {
	//get connection
	$mailbox = mailBoxConnection($folder);
	

	//define vars
	$emails = array();

	$checkerList = imap_check($mailbox);
	$numMessages = $checkerList->Nmsgs;

	$emailsList = imap_fetch_overview($mailbox,"1:{$numMessages}",0);
	
	

	// Sorting the Array - Most Recent First
	$finalEmailsList = array(); 
    if ($emailsList) { 
        foreach ($emailsList as $msg) { 
            $finalEmailsList[$msg->udate] = $msg; 
        } 
    } 
    //sorting DESC DATE
    krsort($finalEmailsList); 

	
	//process emails
	foreach ($emailsList as $email) {
		//process data 
		$mailDateEdited = date('d-m-Y H:i:s', $email->udate);

		//process unseen/seen flag
		if ($email->seen == 0)
			$unseenFlag = false;
		else
			$unseenFlag = true;

		//process flags
		if ($email->flagged == 0)
			$flaggedFlag = false;
		else
			$flaggedFlag = true;
		
		$header = imap_headerinfo($mailbox, $email->msgno);
		
		
		$emailFrom = str_replace("_"," ", mb_decode_mimeheader($email->from));
		$emailFromAdd = $header->from[0]->mailbox . "@" . $header->from[0]->host;
		$emailTo = str_replace("_"," ", mb_decode_mimeheader($email->to));
		$subjectEdited = str_replace("_"," ", mb_decode_mimeheader($email->subject));
		
		
		

		//total attachments
		// $mailStruct = imap_fetchstructure($mailbox, $email->msgno);
		// $attachmentsList = getTotalAttachments($mailbox, $email->msgno, $mailStruct, "");
		// $counterAttachment = 0;
		// //count attachements
		// foreach ($attachmentsList as $attachment) {
		// 	if (isset($attachment['name'])) {
		// 		$counterAttachment++;
		// 	}
		// }

		//prepare email line
		$details = array(
		    "uID" => $email->msgno, 
		    "fromName" => $emailFrom,
		    "fromAddr" => $emailFromAdd,
		    "replyAddr" => $emailFrom, 
	    	"toAddr" => $emailTo,
		    "subject" => $subjectEdited,
		    "udate" => $email->udate, 
		    "mailDate" => $mailDateEdited,
		    "Unseen" => $unseenFlag, 
		    "Flagged" => $flaggedFlag, 
		    "attachments" => 0,
		    // "attachments" => $counterAttachment,
		);

		//push into main array
		$emails[] = $details;

	    // echo "#{$overview->msgno} ({$overview->date}) - From: {$overview->from}
	    // {$overview->subject}\n";
	}

	//process emails
	// for ($i = $numMessages; $i > $limitEmail; $i--) {
	// 	//get headers
	// 	$header = imap_header($mailbox, $i);

	// 	//get general headers sections
	// 	$fromInfo = $header -> from[0];
	// 	$toInfo = $header -> to[0];
	// 	$replyInfo = $header -> reply_to[0];

	// 	//process flags
	// 	$unseenFlag = true;
	// 	if (isset($header -> Unseen)) {
	// 		if ($header -> Unseen == 'U')
	// 			$unseenFlag = false;
	// 		else
	// 			$unseenFlag = true;
	// 	} else
	// 		$unseenFlag = true;

	// 	//process flags
	// 	$flaggedFlag = false;
	// 	if (isset($header -> Flagged)) {
	// 		if ($header -> Flagged == 'F')
	// 			$flaggedFlag = true;
	// 		else
	// 			$flaggedFlag = false;
	// 	} else
	// 		$flaggedFlag = false;

	// 	//total attachments
	// 	$mailStruct = imap_fetchstructure($mailbox, $i);
	// 	$attachmentsList = getTotalAttachments($mailbox, $i, $mailStruct, "");

	// 	$counterAttachment = 0;
	// 	//count attachements
	// 	foreach ($attachmentsList as $attachment) {
	// 		if (isset($attachment['name'])) {
	// 			$counterAttachment++;
	// 		}
	// 	}

	// 	//process data and change from month string to number
	// 	if (isset($header -> MailDate)) {
	// 		$dataTmp = substr($header -> MailDate, 0, 20);
	// 		$dataProcessed = normalizeMailDate($dataTmp);
	// 	} else {
	// 		$dataProcessed = '';
	// 	}

	// 	//prepare email line
	// 	$details = array(
	// 	    "uID" => $i, 
	// 	    "fromAddr" => (isset($fromInfo -> mailbox) && isset($fromInfo -> host)) ? $fromInfo -> mailbox . "@" . $fromInfo -> host : "", 
	// 	    "fromName" => (isset($fromInfo -> personal)) ? $fromInfo -> personal : "", "toAddr" => (isset($toInfo -> mailbox) && isset($toInfo -> host)) ? $toInfo -> mailbox . "@" . $toInfo -> host : "", 
	// 	    "replyAddr" => (isset($replyInfo -> mailbox) && isset($replyInfo -> host)) ? $replyInfo -> mailbox . "@" . $replyInfo -> host : "", 
	// 	    "replyName" => (isset($replyTo -> personal)) ? $replyto -> personal : "", 
	// 	    "subject" => (isset($header -> subject)) ? imap_utf8($header -> subject) : "", 
	// 	    "udate" => (isset($header -> udate)) ? $header -> udate : "", 
	// 	    "mailDate" => (isset($header -> MailDate)) ? $dataProcessed : "", 
	// 	    "Unseen" => $unseenFlag, 
	// 	    "Flagged" => $flaggedFlag, 
	// 	    "attachments" => $counterAttachment,
	// 	// "attachments" => $totalAttachments,
	// 	);

	// 	//push into main array
	// 	$emails[] = $details;
	// }

	//close imap connection
	imap_close($mailbox);

	//return emails and total emails
	return array("numEmails" => $numMessages, "emails" => $emails);
}

// var_dump(getEmailsList());

/**
 * Get details for single email
 * @param  $uID
 * @return details array
 */
function getSingleEmail($uID, $folder = '') {
	//get connection
	$mbox = mailBoxConnection($folder);

    // input $mbox = IMAP stream, $uID = message id
    // output all the following:
    global $charset,$htmlmsg,$plainmsg,$attachments;
    $htmlmsg = $plainmsg = $charset = '';
    $attachments = array();
    $result = array();
		
	$uid = $uID;

    // HEADER
    $header = imap_header($mbox,$uID);
	$fromInfo = $header -> from[0];
	$toInfo = $header -> to[0];
	$replyInfo = $header -> reply_to[0];

	//process flags
	$unseenFlag = true;
	if (isset($header -> Unseen)) {
		if ($header -> Unseen == 'U')
			$unseenFlag = false;
		else
			$unseenFlag = true;
	} else
		$unseenFlag = true;

	//process flags
	$flaggedFlag = false;
	if (isset($header -> Flagged)) {
		if ($header -> Flagged == 'F')
			$flaggedFlag = true;
		else
			$flaggedFlag = false;
	} else
		$flaggedFlag = false;

	//total attachments
	$mailStruct = imap_fetchstructure($mbox, $uid);
	//process data and change from month string to number
	if (isset($header -> MailDate)) {
		$dataTmp = substr($header -> MailDate, 0, 20);
		$dataProcessed = normalizeMailDate($dataTmp);
	} else {
		$dataProcessed = '';
	}
    // add code here to get date, from, to, cc, subject...

    // BODY
    $s = imap_fetchstructure($mbox,$uID);
	//var_dump($s);
    if (!$s->parts){  // simple
        $result = getpart($mbox,$uID,$s,0);  // pass 0 as part-number
    }else {  // multipart: cycle through each part
        foreach ($s->parts as $partno0=>$p){
           $result =  getpart($mbox,$uID,$p,$partno0+1);
		}
    }
		
	$assunto = $header -> subject;
	
	$assunto = str_replace("_"," ", mb_decode_mimeheader($assunto));
	
	//prepare email line
	$details = array(
	    "uID" => $uid, 
	    "fromAddr" => (isset($fromInfo -> mailbox) && isset($fromInfo -> host)) ? $fromInfo -> mailbox . "@" . $fromInfo -> host : "", 
	    "fromName" => (isset($fromInfo -> personal)) ? $fromInfo -> personal : "", 
	    "toAddr" => (isset($toInfo -> mailbox) && isset($toInfo -> host)) ? $toInfo -> mailbox . "@" . $toInfo -> host : "", 
	    "replyAddr" => (isset($replyInfo -> mailbox) && isset($replyInfo -> host)) ? $replyInfo -> mailbox . "@" . $replyInfo -> host : "", 
	    "replyName" => (isset($replyTo -> personal)) ? $replyto -> personal : "", 
	    "subject" => (isset($assunto)) ? $assunto : "", 
	    "udate" => (isset($header -> udate)) ? $header -> udate : "", 
	    "mailDate" => (isset($header -> MailDate)) ? $dataProcessed : "", 
	    "Unseen" => $unseenFlag, 
	    "Flagged" => $flaggedFlag, 
	    "plainTextBody" => $result["plain_text"], 
	    "htmlBody" => $result["html_text"], );
		
		// var_dump($details);
	return $details;
}


function deleteEmail($uID, $folder = '') {
	$mbox = mailBoxConnection($folder);
	imap_delete($mbox, $uID);
}

function expungeEmail($folder = '') {
	$mbox = mailBoxConnection($folder);
	imap_expunge($mbox);
}


/**
 * Get Other Pats
 * @param  [type]  $imap       [description]
 * @param  [type]  $uid        [description]
 * @param  [type]  $mimetype   [description]
 * @param  boolean $structure  [description]
 * @param  boolean $partNumber [description]
 * @return [type]              [description]
 */
function getpart($mbox,$mid,$p,$partno) {
    // $partno = '1', '2', '2.1', '2.1.3', etc for multipart, 0 if simple
    global $htmlmsg,$plainmsg,$charset,$attachments;

    // DECODE DATA
    $data = ($partno)?
        imap_fetchbody($mbox,$mid,$partno):  // multipart
        imap_body($mbox,$mid);  // simple
    // Any part may be encoded, even plain text messages, so check everything.
    if ($p->encoding==4)
        $data = quoted_printable_decode($data);
    elseif ($p->encoding==3)
        $data = base64_decode($data);

    // PARAMETERS
    // get all parameters, like charset, filenames of attachments, etc.
    $params = array();
    if ($p->parameters)
        foreach ($p->parameters as $x)
            $params[strtolower($x->attribute)] = $x->value;
    if ($p->dparameters)
        foreach ($p->dparameters as $x)
            $params[strtolower($x->attribute)] = $x->value;

    // ATTACHMENT
    // Any part with a filename is an attachment,
    // so an attached text file (type 0) is not mistaken as the message.
    if ($params['filename'] || $params['name']) {
        // filename may be given as 'Filename' or 'Name' or both
        $filename = ($params['filename'])? $params['filename'] : $params['name'];
        // filename may be encoded, so see imap_mime_header_decode()
        $attachments[$filename] = $data;  // this is a problem if two files have same name
    }

    // TEXT
    if ($p->type==0 && $data) {
        // Messages may be split in different parts because of inline attachments,
        // so append parts together with blank row.
        if (strtolower($p->subtype)=='plain')
            $plainmsg .= trim($data) ."\n\n";
        else
            $htmlmsg .= $data ."<br><br>";
        $charset = $params['charset'];  // assume all parts are same charset
    }
	
	

    // EMBEDDED MESSAGE
    // Many bounce notifications embed the original message as type 2,
    // but AOL uses type 1 (multipart), which is not handled here.
    // There are no PHP functions to parse embedded messages,
    // so this just appends the raw source to the main message.
    elseif ($p->type==2 && $data) {
        $plainmsg .= $data."\n\n";
    }
	//var_dump(utf8_decode($plainmsg));
	//echo $charset;
	
	
	

    // SUBPART RECURSION
    if ($p->parts) {
        foreach ($p->parts as $partno0=>$p2)
            getpart($mbox,$mid,$p2,$partno.'.'.($partno0+1));  // 1.2, 1.2.1, etc.
    }
	//$plainmsg=str_to_utf8($plainmsg);
	//var_dump($htmlmsg);
	if($plainmsg==""){
		$plainmsg = preg_replace('/(<(script|style)\b[^>]*>).*?(<\/\2>)/is', "$1$3", $htmlmsg);
		$plainmsg = strip_tags($plainmsg,"<br>");
        $plainmsg=htmlspecialchars_decode($plainmsg);
       	$plainmsg=str_replace("&nbsp;", " ", $plainmsg);
       	$plainmsg = preg_replace("/[\n\r]/","",$plainmsg);
		$breaks = array("<br />","<br>","<br/>");
		$plainmsg = str_ireplace($breaks, "\r\n", $plainmsg);  
		
	}
	if( $htmlmsg ==""){
		$htmlmsg = $plainmsg;
		$htmlmsg = nl2br($htmlmsg);
	}
	$array_results = array("plain_text"=>$plainmsg,"html_text"=>$htmlmsg);
	return $array_results;
}
// function getSingleEmail($uID, $folder = '') {
// 	//get connection
// 	$mailbox = mailBoxConnection($folder);

// 	//define vars
// 	$uid = $uID;

// 	/* --------------------- Fill Details ----------------------- */
// 	$header = imap_header($mailbox, $uid);

// 	$fromInfo = $header -> from[0];
// 	$toInfo = $header -> to[0];
// 	$replyInfo = $header -> reply_to[0];

// 	//process flags
// 	$unseenFlag = true;
// 	if (isset($header -> Unseen)) {
// 		if ($header -> Unseen == 'U')
// 			$unseenFlag = false;
// 		else
// 			$unseenFlag = true;
// 	} else
// 		$unseenFlag = true;

// 	//process flags
// 	$flaggedFlag = false;
// 	if (isset($header -> Flagged)) {
// 		if ($header -> Flagged == 'F')
// 			$flaggedFlag = true;
// 		else
// 			$flaggedFlag = false;
// 	} else
// 		$flaggedFlag = false;

// 	//total attachments
// 	$mailStruct = imap_fetchstructure($mailbox, $uid);
// 	//process data and change from month string to number
// 	if (isset($header -> MailDate)) {
// 		$dataTmp = substr($header -> MailDate, 0, 20);
// 		$dataProcessed = normalizeMailDate($dataTmp);
// 	} else {
// 		$dataProcessed = '';
// 	}

// 	//get body
// 	$imapUID = imap_uid($mailbox, $uid);
// 	$plainTextBody = getPlainText($mailbox, $imapUID);
// 	$htmlBody = getBody($imapUID, $mailbox);

// 	if (strlen($plainTextBody) > 2000)
// 		$plainTextBody = substr($plainTextBody, 0, 1997) . '...';

// 	if (isHTML($htmlBody)) {
// 		$htmlBody = delete_all_between("<head>", "</head>", $htmlBody);
// 		$htmlBody = strstr($htmlBody, '>');
// 			$htmlBody = "<html" . $htmlBody;
// 		$htmlBody = get_string_between("<html>", "</html>", $htmlBody);
// 		if (preg_match('/body/', $htmlBody)) {
// 			$htmlBody = strstr($htmlBody, '>');
// 			$htmlBody = "<body" . $htmlBody;
// 			$htmlBody = get_string_between("<body>", "</body>", $htmlBody);
// 		}
// 		// var_dump($htmlBody);
// 		// $htmlBody = utf8_decode($htmlBody) ;
// 		// $htmlBody = str_replace("'", " ", $htmlBody);
// 		$htmlBody = "<body>" . $htmlBody . "</body>";
// 	}
// 		$plainTextBody = strip_tags($htmlBody);
// 		$plainTextBody=htmlspecialchars_decode($plainTextBody);
// 		$plainTextBody=str_replace("&nbsp;", " ", $plainTextBody);
// 		$htmlBody=nl2br($htmlBody);
		
		
// 	//prepare email line
// 	$details = array(
// 	    "uID" => $uid, 
// 	    "fromAddr" => (isset($fromInfo -> mailbox) && isset($fromInfo -> host)) ? $fromInfo -> mailbox . "@" . $fromInfo -> host : "", 
// 	    "fromName" => (isset($fromInfo -> personal)) ? $fromInfo -> personal : "", 
// 	    "toAddr" => (isset($toInfo -> mailbox) && isset($toInfo -> host)) ? $toInfo -> mailbox . "@" . $toInfo -> host : "", 
// 	    "replyAddr" => (isset($replyInfo -> mailbox) && isset($replyInfo -> host)) ? $replyInfo -> mailbox . "@" . $replyInfo -> host : "", 
// 	    "replyName" => (isset($replyTo -> personal)) ? $replyto -> personal : "", 
// 	    "subject" => (isset($header -> subject)) ? imap_utf8($header -> subject) : "", 
// 	    "udate" => (isset($header -> udate)) ? $header -> udate : "", 
// 	    "mailDate" => (isset($header -> MailDate)) ? $dataProcessed : "", 
// 	    "Unseen" => $unseenFlag, 
// 	    "Flagged" => $flaggedFlag, 
// 	    "plainTextBody" => $plainTextBody, 
// 	    "htmlBody" => $htmlBody, );
// 	/* ---------------------------------------------------------- */

// 	//close imap connection
// 	imap_close($mailbox);

// 	//return
// 	return $details;
// }
// var_dump(getSingleEmail(21));

/**
 * Get The List of attachments
 * @param  $uID
 * @return attachments
 */
function getAttachmentsList($uID, $folder = '') {
	
	global $global_array_att;
	//get connection
	$mailbox = mailBoxConnection($folder);

	//define vars
	$uid = $uID;
	$mailStruct = imap_fetchstructure($mailbox, $uid);

	//get Attachments
	getAttachments($mailbox, $uid, $mailStruct, "");
	//var_dump($attachmentsList);
	
	$attachmentsList = $global_array_att;
	

	//process attachments
	$finalAttachments = array();
	foreach ($attachmentsList as $attachment) {
		if (isset($attachment['name'])) {
			$finalAttachments[] = array("uid" => $uid, "part" => $attachment["partNum"], "enc" => $attachment["enc"], "fileName" => $attachment["cleanFile"], "name" => $attachment["name"], );
		
		}
		/*if (isset($attachment[0]['name'])) {
			$finalAttachments[] = array("uid" => $uid, "part" => $attachment[0]["partNum"], "enc" => $attachment[0]["enc"], "fileName" => $attachment[0]["cleanFile"], "name" => $attachment[0]["name"], );
		}*/
	}

	//close imap connection
	imap_close($mailbox);

	//return
	return $finalAttachments;
}

/**
 * Get total Attachments Array
 * @param  $imap
 * @param  $mailNum
 * @param  $part
 * @param  $partNum
 * @return
 */
function getTotalAttachments($imap, $mailNum, $part, $partNum) {
	//define vars
	$attachments = array();
	global $global_array_att;

	//process all attachments and return an array of only names
	if (isset($part -> parts)) {
		foreach ($part->parts as $key => $subpart) {
			if ($partNum != "") {
				$newPartNum = $partNum . "." . ($key + 1);
			} else {
				$newPartNum = ($key + 1);
			}
			$result = getTotalAttachments($imap, $mailNum, $subpart, $newPartNum);
			if (isset($result[0][0]['name'])) {
				foreach ($result as $finalResult) {
					array_push($global_array_att, $finalResult[0]);
				}
			} elseif (count($result) != 0) {
				array_push($global_array_att, $result);
			}
		}
	} else if (isset($part -> disposition)) {
		if (strtoupper($part -> disposition) == "ATTACHMENT") {
			$partStruct = imap_bodystruct($imap, $mailNum, $partNum);

			$attachmentDetails = array("name" => $part -> dparameters[0] -> value, );
			return $attachmentDetails;
		}

		//get any inline attachments
		if (strtoupper($part -> disposition) == "INLINE") {
			$partStruct = imap_bodystruct($imap, $mailNum, $partNum);

			$attachmentsTemp = array();

			foreach ($part->dparameters as $dparameters) {

				$attachmentDetails = array("name" => $dparameters -> value, );
				array_push($attachmentsTemp, $attachmentDetails);
			}
			return $attachmentsTemp;
		}
	}
		
	// print_r($attachments);
	return $attachments;
}

/**
 * Get Attachments List
 * @param  $imap
 * @param  $mailNum
 * @param  $part
 * @param  $partNum
 * @return -------
 */
function getAttachments($imap, $mailNum, $part, $partNum) {
	
	
	global $global_array_att;
	$attachments = array();

	if (isset($part -> parts)) {
		foreach ($part->parts as $key => $subpart) {
			if ($partNum != "") {
				$newPartNum = $partNum . "." . ($key + 1);
			} else {
				$newPartNum = ($key + 1);
			}
			$result = getAttachments($imap, $mailNum, $subpart, $newPartNum);
			
			if (isset($result[0][0])) {
				foreach ($result as $finalResult) {
					array_push($global_array_att, $finalResult[0]);
				}
			} elseif (count($result) != 0) {
				array_push($global_array_att, $result);
			}
		}
	} else if (isset($part -> disposition)) {
		
		if (strtoupper($part -> disposition) == "ATTACHMENT") {
			$partStruct = imap_bodystruct($imap, $mailNum, $partNum);

			if( isset($part -> dparameters) ){
				$cleanFile = cleanString($part -> dparameters[0] -> value);
					//var_dump($partStruct -> subtype);
				if (strtolower($partStruct -> subtype) == 'plain') {
					$cleanFile .= ".txt";
				} else {
					$cleanFile .= "." . strtolower($partStruct -> subtype);
				}
				
				if(strtolower($partStruct -> subtype)=='html' || strtolower($partStruct -> subtype)=='xml'){
					$attachmentDetails = array("name" => $part -> dparameters[0] -> value, "cleanFile" => $cleanFile, "subtype" => $partStruct -> subtype, "partNum" => $partNum, "enc" => $partStruct -> encoding);
					
				}
			}elseif(isset($part -> parameters)){
				$specialExt = '';
				$cleanFile = cleanString($part -> parameters[0] -> value);
					//var_dump($partStruct -> subtype);
				if (strtolower($partStruct -> subtype) == 'plain') {
					$cleanFile .= ".txt";
				} elseif(strtolower($partStruct -> subtype) == 'octet-stream'){
					$ext = explode(".", $part -> parameters[0] -> value);
					$ext = end($ext);
					$specialExt = $ext;

					$cleanFile .= "." . strtolower($ext);
				} else {
					$cleanFile .= "." . strtolower($partStruct -> subtype);
				}
				
				if(strtolower($partStruct -> subtype)=='html' || strtolower($partStruct -> subtype)=='xml'){
					$attachmentDetails = array("name" => $part -> parameters[0] -> value, "cleanFile" => $cleanFile, "subtype" => $partStruct -> subtype, "partNum" => $partNum, "enc" => $partStruct -> encoding);
				}elseif(strtolower($specialExt)=='xml'){
					$attachmentDetails = array("name" => $part -> parameters[0] -> value, "cleanFile" => $cleanFile, "subtype" => $specialExt, "partNum" => $partNum, "enc" => $partStruct -> encoding);
				}
			}

			

			return $attachmentDetails;
		}

		//get any inline attachments
		if (strtoupper($part -> disposition) == "INLINE") {
			$partStruct = imap_bodystruct($imap, $mailNum, $partNum);

			$attachmentsTemp = array();

			foreach ($part->dparameters as $dparameters) {

				$cleanFile = cleanString($dparameters -> value);
				if (strtolower($partStruct -> subtype) == 'plain') {
					$cleanFile .= ".txt";
				} else {
					$cleanFile .= "." . strtolower($partStruct -> subtype);
				}

				$attachmentDetails = array("name" => $dparameters -> value, "cleanFile" => $cleanFile, "subtype" => $partStruct -> subtype, "partNum" => $partNum, "enc" => $partStruct -> encoding);
				array_push($attachmentsTemp, $attachmentDetails);
			}
			return $attachmentsTemp;
		}
	}
//print_r($global_array_att);


	// var_dump($attachments);
	return $attachments;
}

/**
 * Get body content
 * @param  [type] $uid  [description]
 * @param  [type] $imap [description]
 * @return [type]       [description]
 */
function getBody($uid, $imap) {
	$body = get_part($imap, $uid, "TEXT/HTML");
	// if HTML body is empty, try getting text body
	if ($body == "") {
		$body = get_part($imap, $uid, "TEXT/PLAIN");
	}
	return $body;
}

/**
 * Get Other Pats
 * @param  [type]  $imap       [description]
 * @param  [type]  $uid        [description]
 * @param  [type]  $mimetype   [description]
 * @param  boolean $structure  [description]
 * @param  boolean $partNumber [description]
 * @return [type]              [description]
 */
function get_part($imap, $uid, $mimetype, $structure = false, $partNumber = false) {
	if (!$structure) {
		$structure = imap_fetchstructure($imap, $uid, FT_UID);
	}
	if ($structure) {
		if ($mimetype == get_mime_type($structure)) {
			/*if (!$partNumber) {
			 $partNumber = 1;
			 }*/
			//$text = imap_fetchbody($imap, $uid, $partNumber, FT_UID);
			
			$text =  quoted_printable_decode( 
                        imap_fetchbody($imap, $uid, $partNumber, FT_UID ) );
			
			if($structure->parameters[0]->value!="utf-8" && $structure->parameters[0]->value!="UTF-8"){
				
				$text = utf8_encode($text);
			}
			$text = trim($text);
			
			
			switch ($structure->encoding) {
				case 1 :
					return imap_8bit($text);
				case 2 :
					return imap_binary($text);
				case 3 :
					return imap_base64($text);
				case 4 :
					return $text;
							
				default :
					return $text;
			}
		}

		// multipart
		if ($structure -> type == 1) {
			foreach ($structure->parts as $index => $subStruct) {
				$prefix = "";
				/*if ($partNumber) {
				 $prefix = $partNumber . ".";
				 }*/
				$data = get_part($imap, $uid, $mimetype, $subStruct, $prefix . ($index + 1));
				if ($data) {
					return $data;
				}
			}
		}
	}
	return false;
}

/**
 * Get Mime types
 * @param  [type] $structure [description]
 * @return [type]            [description]
 */
function get_mime_type($structure) {
	$primaryMimetype = array("TEXT", "MULTIPART", "MESSAGE", "APPLICATION", "AUDIO", "IMAGE", "VIDEO", "OTHER");

	if ($structure -> subtype) {
		return $primaryMimetype[(int)$structure -> type] . "/" . $structure -> subtype;
	}
	return "TEXT/PLAIN";
}

/**
 * Get plain text version
 * @param  [type] $imap [description]
 * @param  [type] $uid  [description]
 * @return [type]       [description]
 */
function getPlainText($imap, $uid) {

	$mimetype = "TEXT/PLAIN";

	$structure = imap_fetchstructure($imap, $uid, FT_UID);

	$message = '';

	if ($structure) {
		if ($mimetype == get_mime_type($structure)) {
			if (!$partNumber) {
				$partNumber = 1;
			}
			$text = imap_fetchbody($imap, $uid, $partNumber, FT_UID);
			switch ($structure->encoding) {
				case 1 :
					$message = imap_8bit($text);
					break;
				case 3 :
					$message = imap_base64($text);
					break;
				case 4 :
					$message = imap_qprint($text);
					break;
				default :
					$message = strip_html_tags(quoted_printable_decode($text));
					break;
			}
		}

		// multipart
		if ($structure -> type == 1) {
			foreach ($structure->parts as $index => $subStruct) {
				$prefix = "";
				if ($partNumber) {
					$prefix = $partNumber . ".";
				}
				$data = get_part($imap, $uid, $mimetype, $subStruct, $prefix . ($index + 1));
				if ($data) {
					$message = $data;
				}
			}
		}
	}
	//try to clean html version when plain text is empty
	if (empty($message)) {
		$HTML = getBody($uid, $imap);
		$message = strip_html_tags($HTML);
	}

	//get only 1500 chars for bigger plain texts
	if (strlen($message) > 1500) {
		$message = substr($message, 0, 1500);
	}

	//test if can json_encode this // if not return like the 'empty $message'
	if (json_encode($message)) {
	} else {
		$HTML = getBody($uid, $imap);
		$message = strip_html_tags($HTML);
	}

	//response
	return $message;
}

/**
 * Download Attachments
 * @param  $imap
 * @param  $uid
 * @return -------
 */
function downloadAllAttachments($uid, $folder = '', $uploadFolder = '') {
	
	global  $global_array_att;
	
	//get connection
	$mailbox = mailBoxConnection($folder);

	//get mail structure
	$structure = imap_fetchstructure($mailbox, $uid);

	//get attachments list
	getAttachments($mailbox, $uid, $structure, "");
	
	$attachments = $global_array_att;

	$downAttachments = array();
	//process attachments download
	foreach ($attachments as $attachment) {
		if (isset($attachment['name'])) {
			//prepare vars
			// $finalName = time() . "_" . $attachment['cleanFile'];
			$finalName = $attachment['cleanFile'];

			//get attachment
			$attachmentBody = imap_fetchbody($mailbox, $uid, $attachment['partNum']);
			$attachmentDecoded = $attachmentBody;

			//process attachment
			if ($attachment['enc'] == 3) {// 3 = BASE64
				$attachmentDecoded = base64_decode($attachmentBody);
			} elseif ($attachment['enc'] == 4) {// 4 = QUOTED-PRINTABLE
				$attachmentDecoded = quoted_printable_decode($attachmentBody);
			}

			//download into the server
			$result = file_put_contents($uploadFolder.'/' . $finalName, $attachmentDecoded);

			//process answer
			if ($result) {
				$downAttachments[] = array('Titulo' => $finalName, 'Anexo' => $finalName );
			}
		}
	}

	//close imap connection
	imap_close($mailbox);

	//return
	return $downAttachments;
}

/**
 * Download Single File
 * @param  $mailbox
 * @param  $uid
 * @param  $fileName
 * @param  $partNum
 * @param  $encode
 * @return file with link
 */
function downloadSingleAttachment($uid, $fileName, $partNum, $encode, $folder = '', $uploadFolder = '') {
	//get connection
	$mailbox = mailBoxConnection($folder);

	//prepare vars
	$finalName = rand().time() . "_" . $fileName;

	//get attachment
	$attachment = imap_fetchbody($mailbox, $uid, $partNum);
	$attachmentDecoded = $attachment;

	//process attachment
	if ($encode == 3) {// 3 = BASE64
		$attachmentDecoded = base64_decode($attachment);
	} elseif ($encode == 4) {// 4 = QUOTED-PRINTABLE
		$attachmentDecoded = quoted_printable_decode($attachment);
	}

	//download into the server
	$result = file_put_contents($_SERVER["DOCUMENT_ROOT"] . '/'.$uploadFolder.'/' . $finalName, $attachmentDecoded);

	//close imap connection
	imap_close($mailbox);

	//process answer
	if ($result) {
		$downAttachments = array('uID' => $uid, 'Titulo' => $finalName, 'Anexo' => $finalName, );

		//return
		return $downAttachments;
	} else
		return false;
}

/**
 * |--------------------------------------------------------------------------------
 * | # HELPER FUNCTIONS
 * |--------------------------------------------------------------------------------
 */

//normalize the email date with only numbers
function normalizeMailDate($mailDate) {
	$dataProcessed = $mailDate;
	$dataTmp = explode('-', $mailDate);

	//process months
	switch ($dataTmp[1]) {
		//EN -----------------------------------------------------------------------
		case 'Jan' :
			$dataProcessed = str_replace('Jan', '01', $dataProcessed);
			break;
		case 'Feb' :
			$dataProcessed = str_replace('Feb', '02', $dataProcessed);
			break;
		case 'Mar' :
			$dataProcessed = str_replace('Mar', '03', $dataProcessed);
			break;
		case 'Apr' :
			$dataProcessed = str_replace('Apr', '04', $dataProcessed);
			break;
		case 'May' :
			$dataProcessed = str_replace('May', '05', $dataProcessed);
			break;
		case 'Jun' :
			$dataProcessed = str_replace('Jun', '06', $dataProcessed);
			break;
		case 'Jul' :
			$dataProcessed = str_replace('Jul', '07', $dataProcessed);
			break;
		case 'Aug' :
			$dataProcessed = str_replace('Aug', '08', $dataProcessed);
			break;
		case 'Sep' :
			$dataProcessed = str_replace('Sep', '09', $dataProcessed);
			break;
		case 'Oct' :
			$dataProcessed = str_replace('Oct', '10', $dataProcessed);
			break;
		case 'Nov' :
			$dataProcessed = str_replace('Nov', '11', $dataProcessed);
			break;
		case 'Dec' :
			$dataProcessed = str_replace('Dec', '12', $dataProcessed);
			break;

		//PT -----------------------------------------------------------------------
		case 'Jan' :
			$dataProcessed = str_replace('Jan', '01', $dataProcessed);
			break;
		case 'Fev' :
			$dataProcessed = str_replace('Feb', '02', $dataProcessed);
			break;
		case 'Mar' :
			$dataProcessed = str_replace('Mar', '03', $dataProcessed);
			break;
		case 'Abr' :
			$dataProcessed = str_replace('Apr', '04', $dataProcessed);
			break;
		case 'Mai' :
			$dataProcessed = str_replace('May', '05', $dataProcessed);
			break;
		case 'Jun' :
			$dataProcessed = str_replace('Jun', '06', $dataProcessed);
			break;
		case 'Jul' :
			$dataProcessed = str_replace('Jul', '07', $dataProcessed);
			break;
		case 'Ago' :
			$dataProcessed = str_replace('Aug', '08', $dataProcessed);
			break;
		case 'Set' :
			$dataProcessed = str_replace('Sep', '09', $dataProcessed);
			break;
		case 'Out' :
			$dataProcessed = str_replace('Oct', '10', $dataProcessed);
			break;
		case 'Nov' :
			$dataProcessed = str_replace('Nov', '11', $dataProcessed);
			break;
		case 'Dez' :
			$dataProcessed = str_replace('Dec', '12', $dataProcessed);
			break;

		default :
			break;
	}
	//correct hours to 24h format
	$dataTmp2 = explode('-', $dataProcessed);
	$day = trim($dataTmp2[0]);

	$search = $dataTmp2[0] . '-' . $dataTmp2[1];
	$replaceFor = '0' . $day . '-' . $dataTmp2[1];

	if ($day < 10)
		$dataProcessed = str_replace($search, $replaceFor, $dataProcessed);

	//return date normalized
	return $dataProcessed;
}

//To remove all the hidden text not displayed on a webpage
function strip_html_tags($str) {
	$str = preg_replace('/(<|>)\1{2}/is', '', $str);
	$str = preg_replace(array(// Remove invisible content
	'@<head[^>]*?>.*?</head>@siu', '@<style[^>]*?>.*?</style>@siu', '@<script[^>]*?.*?</script>@siu', '@<noscript[^>]*?.*?</noscript>@siu', ), "", //replace above with nothing
	$str);
	$str = strip_tags($str);
	$str = replaceWhitespace($str);
	return $str;
}//function strip_html_tags ENDS

//To replace all types of whitespace with a single space
function replaceWhitespace($str) {
	$result = $str;
	$toReplace = array(
	// "<html>","</html>","<body>","</body>",
	"  ", " \t", " \r", " \n", "\t\t", "\t ", "\t\r", "\t\n", "\r\r", "\r ", "\r\t", "\r\n", "\n\n", "\n ", "\n\t", "\n\r", "<", "/>", ">", "mailto:", "<p>", "</p>", "/p ", "p ");
	foreach ($toReplace as $replacement) {
		$result = str_replace($replacement, " ", $result);
	}
	return $str !== $result ? replaceWhitespace($result) : $result;
}

//to clean a string
function cleanString($string) {
	$string = str_replace(' ', '_', $string);
	// Replaces all spaces with hyphens.
	$string = preg_replace('/[^A-Za-z0-9\-]/', '', $string);
	// Removes special chars.

	return preg_replace('/-+/', '_', $string);
	// Replaces multiple hyphens with single one.
}

function isHTML($str) {
	return preg_match("/\/[a-z]*>/i", $str) != 0;
}

function delete_all_between($beginning, $end, $string) {
	$beginningPos = strpos($string, $beginning);
	$endPos = strpos($string, $end);
	if ($beginningPos === false || $endPos === false) {
		return $string;
	}

	$textToDelete = substr($string, $beginningPos, ($endPos + strlen($end)) - $beginningPos);

	return str_replace($textToDelete, '', $string);
}

function get_string_between($start, $end, $string) {
	$string = ' ' . $string;
	$ini = strpos($string, $start);
	if ($ini == 0)
		return '';
	$ini += strlen($start);
	$len = strpos($string, $end, $ini) - $ini;
	return substr($string, $ini, $len);
}

function decode_qprint($str) {

	$str = preg_replace("/\=([A-F][A-F0-9])/", "%$1", $str);
	$str = urldecode($str);

	$str = iconv("ISO-8859-1", "UTF-8", $str);
	return $str;
}

function decode_mystr($str, $codedUTF8 = false) {
	//clean string trash
	$str = str_replace("=?iso-8859-1?Q?", "", $str);
	$str = str_replace("=?iso8859-1?Q?", "", $str);
	$str = str_replace("=?utf-8?Q?", "", $str);
	$str = str_replace("?=", "", $str);

	$array_chars = array("À", "Á", "Â", "Ã", "Ä", "Å", "Æ", "Ç", "È", "É", "Ê", "Ë", "Ì", "Í", "Î", "Ï", "Ð", "Ñ", "Ò", "Ó", "Ô", "Õ", "Ö", "×", "Ø", "Ù", "Ú", "Û", "Ü", "Ý", "Þ", "ß", "à", "á", "â", "ã", "ä", "å", "æ", "ç", "è", "é", "ê", "ë", "ì", "í", "î", "ï", "ð", "ñ", "ò", "ó", "ô", "õ", "ö", "÷", "ø", "ù", "ú", "û", "ü", "ý", "þ", "ÿ", " ", "£", "-", " ", "" );

	$array_coded = array("=C0", "=C1", "=C2", "=C3", "=C4", "=C5", "=C6", "=C7", "=C8", "=C9", "=CA", "=CB", "=CC", "=CD", "=CE", "=CF", "=D0", "=D1", "=D2", "=D3", "=D4", "=D5", "=D6", "=D7", "=D8", "=D9", "=DA", "=DB", "=DC", "=DD", "=DE", "=DF", "=E0", "=E1", "=E2", "=E3", "=E4", "=E5", "=E6", "=E7", "=E8", "=E9", "=EA", "=EB", "=EC", "=ED", "=EE", "=EF", "=F0", "=F1", "=F2", "=F3", "=F4", "=F5", "=F6", "=F7", "=F8", "=F9", "=FA", "=FB", "=FC", "=FD", "=FE", "=FF", "=20", "=A3", "=2D" ,"=A0", "=AD");

	$array_coded_utf8 = array("=C3=80", "=C3=81", "=C3=82", "=C3=83", "=C3=84", "=C3=85", "=C3=86", "=C3=87", "=C3=88", "=C3=89", "=C3=8A", "=C3=8B", "=C3=8C", "=C3=8D", "=C3=8E", "=C3=8F", "=C3=90", "=C3=91", "=C3=92", "=C3=93", "=C3=94", "=C3=95", "=C3=96", "=C3=97", "=C3=98", "=C3=99", "=C3=9A", "=C3=9B", "=C3=9C", "=C3=9D", "=C3=9E", "=C3=9F", "=C3=A0", "=C3=A1", "=C3=A2", "=C3=A3", "=C3=A4", "=C3=A5", "=C3=A6", "=C3=A7", "=C3=A8", "=C3=A9", "=C3=AA", "=C3=AB", "=C3=AC", "=C3=AD", "=C3=AE", "=C3=AF", "=C3=B0", "=C3=B1", "=C3=B2", "=C3=B3", "=C3=B4", "=C3=B5", "=C3=B6", "=C3=B7", "=C3=B8", "=C3=B9", "=C3=BA", "=C3=BB", "=C3=BC", "=C3=BD", "=C3=BE", "=C3=BF", "=20", "=A3", "=2D" ,"=C2=A0", "=C2=AD");

	$size = sizeof($array_chars);

	for ($i = 0; $i < $size; $i++) {
		
		if( $codedUTF8 == true ) $str = str_replace($array_coded[$i], $array_chars[$i], $str);
		else$str = str_replace($array_coded[$i], $array_chars[$i], $str);

	}

	return $str;
}
// " ", "£", "-", " ", ""
// "=20", "=A3", "=2D" ,"=A0", "=AD"
//downloadAllAttachments(3752);
//var_dump( downloadAllAttachments(3752) );
// var_dump( downloadSingleAttachment(9,"IMG0293PNG.png","2.2",3) );
// var_dump( downloadAllAttachments(9) );
?>