<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//VALIDATE NIF FUNCTION -------------------------------------------------
function validaNIF($nif, $ignoreFirst=true) {
	return true;
	
	//Limpamos eventuais espaços a mais
	$nif=trim($nif);
	//Verificamos se é numérico e tem comprimento 9
	if (!is_numeric($nif) || strlen($nif)!=9) {
		return false;
	} else {
		$nifSplit=str_split($nif);
		//O primeiro digíto tem de ser 1, 2, 5, 6, 8 ou 9
		//Ou não, se optarmos por ignorar esta "regra"
		if ( in_array($nifSplit[0], array(1, 2, 3, 5, 6, 8, 9))	||	$ignoreFirst ) {
			//Calculamos o dígito de controlo
			$checkDigit=0;
			for($i=0; $i<8; $i++) {
				$checkDigit+=$nifSplit[$i]*(10-$i-1);
			}
			$checkDigit=11-($checkDigit % 11);
			//Se der 10 então o dígito de controlo tem de ser 0
			if($checkDigit>=10) $checkDigit=0;
			//Comparamos com o último dígito
			if ($checkDigit==$nifSplit[8]) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
}

//GET POST VARS ---------------------------------------------------------
$idDados = 1;

$nome_empresa = $_POST['nome_empresa'];
$nif_empresa = $_POST['nif_empresa'];
$registocomercial_empresa = $_POST['registocomercial_empresa'];
$endereco_empresa = $_POST['endereco_empresa'];
$endereco2_empresa = $_POST['endereco2_empresa'];
$codigopostal_empresa = $_POST['codigopostal_empresa'];
$cidade_empresa = $_POST['cidade_empresa'];
// $tipo_empresa = $_POST['tipo_empresa'];
$tipo_empresa = 0;
$email_empresa = $_POST['email_empresa'];
$website_empresa = $_POST['website_empresa'];
$capital_empresa = $_POST['capital_empresa'];
$conservatoria_empresa = $_POST['conservatoria_empresa'];
$telefone_empresa = $_POST['telefone_empresa'];
$fax_empresa = $_POST['fax_empresa'];
$norma_contabilistica_empresa = $_POST['norma_contabilistica_empresa'];
$cae_empresa = $_POST['cae_empresa'];
$laposte_empresa = $_POST['laposte_empresa'];
$country = $_POST['country'];

$foto = $_POST['foto_empresa'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $nome_empresa == '' || $endereco_empresa == '' || $codigopostal_empresa == '' || $cidade_empresa == '') 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VALIDATE NIF -----------------------------------------------------------
$validNIF = validaNIF($nif_empresa, false);
if($validNIF == false){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["nif_error"] = true;
	$response["line"] = "FATS001";
	die(json_encode($response));
}

//GET PREVIOUS FOTO -------------------------------------------------------
$query = "SELECT Logotipo FROM faturacao_empresa_dados WHERE ID_dados_empresa=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	$stmt -> bind_param("d", $idDados);
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0000";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($fotoDB);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0001";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//CHECK IF FOTO HAS CHANGED ----------------------------------------------
$finalFoto;
if( $fotoDB != $foto && ($foto != ' ' && $foto != '') ){
	$finalFoto = $foto;
	unlink($_SERVER["DOCUMENT_ROOT"] . "/uploads/faturacao/" . $fotoDB);
}else{
	$finalFoto = $fotoDB;
}


//INSERT INTO DB ---------------------------------------------------------
$query = "UPDATE faturacao_empresa_dados SET ";
$query .= "Designacao=?,";
$query .= "Nif=?,";
$query .= "RegistoComercial=?,";
$query .= "Endereco1=?,";
$query .= "Endereco2=?,";
$query .= "CodigoPostal=?,";
$query .= "Cidade=?,";
$query .= "TipoEmpresa=?,";
$query .= "Email=?,";
$query .= "Website=?,";
$query .= "CapitalSocial=?,";
$query .= "Conservatoria=?,";
$query .= "Telefone=?,";
$query .= "Fax=?,";
$query .= "Logotipo=?,";
$query .= "CAE_Principal=?,";
$query .= "LaPosteCodigo=?,";
$query .= "Pays=?";
$query .= " WHERE ID_dados_empresa=?";

if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssssdssssssssssd",
	        $nome_empresa,
			$nif_empresa,
			$registocomercial_empresa,
			$endereco_empresa,
			$endereco2_empresa,
			$codigopostal_empresa,
			$cidade_empresa,
			$tipo_empresa,
			$email_empresa,
			$website_empresa,
			$capital_empresa,
			$conservatoria_empresa,
			$telefone_empresa,
			$fax_empresa,
			$finalFoto,
			$cae_empresa,
			$laposte_empresa,
			$country,
			$idDados 
	    );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["DATA"] = $_POST;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------


//log sistema - processo
$descricao_log ="Modification des données de société";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>