<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDados = $_POST['idImposto'];

//CHECK IF USED (REMOVE ALL PREDEFINIDAS) -------------------------------
$query = "SELECT ID_ImpostoUsado FROM faturacao_impostos_usados WHERE ID_Imposto=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $ID_ImpostoUsado );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add info to main array
if($ID_ImpostoUsado > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_impostos WHERE ID_Imposto=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idDados );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//CHECK IF HAS STANDARD ----------------------------------------
$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Predefinido=1 AND Ativo=1";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	// $stmt -> bind_param("d", $idImposto);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {}
	$stmt -> bind_result($idImpostoPredefinido);
	$stmt -> fetch();
	$stmt -> close();
} else {}

//if smaller than 1 -- auto standard the first item
if($idImpostoPredefinido < 1){
	//clear all standards
	$query = "UPDATE faturacao_impostos SET Predefinido=0";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//add new standard
	$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Ativo=1 LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $idImposto);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {}
		$stmt -> bind_result($idImpostoAtivo);
		$stmt -> fetch();
		$stmt -> close();
	} else {}
	if($idImpostoAtivo > 0){
		//DEFINE NEW STANDARD --------------------------------------
		$query = "UPDATE faturacao_impostos SET Predefinido=1 WHERE ID_Imposto=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			//bind params
			$stmt -> bind_param("d", $idImpostoAtivo);
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> close();
		} else {}
	}
}

//response
$response["errors"] = false;
die(json_encode($response));
?>