<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$id_imposto = $_POST['id_imposto'];
$nome_imposto = $_POST['nome_imposto'];
$valor_imposto = $_POST['valor_imposto'];
$regiao_imposto = $_POST['regiao_imposto'];
$subclasse_imposto = $_POST['subclasse_imposto'];
$descricao_imposto = $_POST['descricao_imposto'];
$flagPredefinirEdit = $_POST['flagPredefinirEdit'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $id_imposto == '' || $nome_imposto == '' || $valor_imposto == '' || $regiao_imposto == '' || $subclasse_imposto == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//UPDATE DB (REMOVE ALL PREDEFINIDAS) -----------------------------------
if($flagPredefinirEdit == 1){
	$query = "UPDATE faturacao_impostos SET Predefinido=0";

	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------

//INSERT DB -------------------------------------------------------------
$query = "UPDATE faturacao_impostos SET Nome=?, Valor=?, Regiao=?, Subclasse=?, Descricao=?, Predefinido=? WHERE ID_Imposto=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssdd", $nome_imposto, $valor_imposto, $regiao_imposto, $subclasse_imposto, $descricao_imposto, $flagPredefinirEdit, $id_imposto );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------

if($flagPredefinirEdit == 0){
	//CHECK IF HAS STANDARD ----------------------------------------
	$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Predefinido=1 AND Ativo=1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $idImposto);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {}
		$stmt -> bind_result($idImpostoPredefinido);
		$stmt -> fetch();
		$stmt -> close();
	} else {}

	//if smaller than 1 -- auto standard the first item
	if($idImpostoPredefinido < 1){
		$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Ativo=1 LIMIT 1";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			// $stmt -> bind_param("d", $idImposto);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result($idImpostoAtivo);
			$stmt -> fetch();
			$stmt -> close();
		} else {}
		if($idImpostoAtivo > 0){
			//DEFINE NEW STANDARD --------------------------------------
			$query = "UPDATE faturacao_impostos SET Predefinido=1 WHERE ID_Imposto=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				//bind params
				$stmt -> bind_param("d", $idImpostoAtivo);
				$result = $stmt -> execute();
				if (false === $result) {}
				$stmt -> close();
			} else {}
		}
	}
}


//response
$response["errors"] = false;
die(json_encode($response));
?>