<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$nome_serie = $_POST['nome_serie'];
$flagPredefinir = $_POST['flagPredefinir'];
$numero_serie_ft = intval($_POST['numero_serie_ft']) > 0 ? intval($_POST['numero_serie_ft']) : 1;
$numero_serie_nc = intval($_POST['numero_serie_nc']) > 0 ? intval($_POST['numero_serie_nc']) : 1;
$numero_serie_gt = intval($_POST['numero_serie_gt']) > 0 ? intval($_POST['numero_serie_gt']) : 1;
$numero_serie_dv = intval($_POST['numero_serie_dv']) > 0 ? intval($_POST['numero_serie_dv']) : 1;
$numero_serie_rg = intval($_POST['numero_serie_rg']) > 0 ? intval($_POST['numero_serie_rg']) : 1;

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $nome_serie == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//UPDATE DB (REMOVE ALL PREDEFINIDAS) -----------------------------------
if($flagPredefinir == 1){
	$query = "UPDATE faturacao_series SET ";
	$query .= "Predefinida=0";

	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------

//INSERT DB -------------------------------------------------------------
$query = "INSERT INTO faturacao_series (Nome, Predefinida, NumeroInicial_FT, NumeroInicial_NC, NumeroInicial_GT, NumeroInicial_DV, NumeroInicial_RG) VALUES(?,?,?,?,?,?,?) ";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sdddddd", $nome_serie, $flagPredefinir, $numero_serie_ft, $numero_serie_nc, $numero_serie_gt, $numero_serie_dv, $numero_serie_rg );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------

//log sistema - processo
$descricao_log ="Création de la série (nom: ".$nome_serie.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>