<?php
ob_start();
session_start();
include "connection.php";
// inclui a conexão a database

if (!$_POST['username'] || !$_POST['password']) {
	$response["errors"] = true;
	$response["type"] = 1;
	$response["message"] = "GESA001x";
	die(json_encode($response));
} else {
	$username = $_POST['username'];
	$password = $_POST['password'];

	function checkDateisValid($data) {
		$hoje = date("Y-m-d");
		$data_validade = date('Y-m-d', strtotime(str_replace('/', '-', $data)));
		if ($hoje > $data_validade) {
			return false;
		} else {
			return true;
		}

	}

	$query = "SELECT utilizador.ID_Utilizador, utilizador.ID_TipoUtilizador, utilizador.ID_Permissao,  utilizador.Nome,  utilizador.Email, Password, Salt, autarquia.ID_Autarquia, autarquia.Nome, autarquia.ID_Distrito, autarquia.ID_Concelho, autarquia.ID_Freguesia, autarquia.Versao from utilizador, autarquia where utilizador.ID_Autarquia=autarquia.ID_Autarquia and Username=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $username);
		$stmt -> execute();
		$stmt -> bind_result($id_utilizador, $tipo_utilizador, $id_permissao, $nome_utilizador, $email_utilizador, $password_bd, $salt, $id_autarquia, $nome_autarquia, $id_distrito, $id_concelho, $id_freguesia, $versao);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = 2;
		$response["message"] = "GESA002x";
		die(json_encode($response));
	}

	$hash = hash('sha256', $password);
	$password_login = hash('sha256', $salt . $hash);

	if ($id_utilizador == "")// User not found. So, redirect to login_form again.
	{

		$response["errors"] = true;
		$response["type"] = 3;
		$response["message"] = "GESA003x";
		die(json_encode($response));

	} else {

		//comparing passwords
		if ($password_login != $password_bd)// Incorrect password. So, redirect to login_form again.
		{
			$response["errors"] = true;
			$response["type"] = 4;
			$response["message"] = "GESA004x";
			die(json_encode($response));

		} else {// Redirect to home page after successful login.

			$data = date('d/m/Y');

			$hora = date('H:i:s');
			if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
				$ip = $_SERVER['HTTP_CLIENT_IP'];
			} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
				$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
			} else {
				$ip = $_SERVER['REMOTE_ADDR'];
			}

			$query = "Insert into log (ID_Utilizador, Data, Hora, IP) values(?,?,?,?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("dsss", $id_utilizador, $data, $hora, $ip);
				$stmt -> execute();
				$stmt -> close();
			} else {

				$response["errors"] = true;
				$response["type"] = 2;
				$response["message"] = "GESA005x";
				die(json_encode($response));
			}
$response["errors"] = false;
				die(json_encode($response));
		}
	}
}
?>